/*------------ Stochastic Phrase Structure Generator by Ivica "Ico" Bukvic -------- --*/

//DEFINE DEBUG 1
//IFDEF DEBUG
//printf("I am debugging\n");
//ENDIF

/*--------------------------------- Init stuff ----------------------------------------*/

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
using namespace std;

typedef short boolean;  //SGI DEFINE BOOL
#define true 1
#define false 0

string version = "0.76.5";

/*------------------------------------ GLOBAL stuff -----------------------------------*/

	//These objects for the final scorefile can be changed in the output menu
	char event1 = 'x'; //under-accented event
	char event2 = '*'; //non-accented event
	char event3 = 'o'; //accented event
	char noevent1 = '|'; //non-zero-accented event
	char noevent2 = '+'; //zero-accented event

	float array[10000][100];
	int accent[10000][100];
	float curves[6][500];
	int temparray[5000][100];
	string final_array[2][10000][100];
	int hearlinearray[10000];

	//string *ptrfinal_array = &final_array[0][0];
	//int *ptrarray = &array[0][0];
	//int *ptrtemparray = &temparray[0][0];
	//int *ptrcurve = &curves[0][0];
	//int *ptraccent = &accent[0][0];

	string name = "spidsig-scorefile.sco"; //this stores the file name

	int lastrep = 0;
	int ncurves = 0;
	int nlines = 0;
	int nunits = 0;
	int nelem = 0;
	int array_nelem = 0;
	int accentlev = 0;

	int *ptrlastrep = &lastrep; //variable that counts how many units are in the last repetition if the last repetition is incomplete
	int *ptraccent = &accentlev;  //NUMBER OF ACCENTUATION LEVELS
	int *ptr_array_nelem = &array_nelem; //total number of "objects" in the template array (and therefore in the final array)
	int *ptrnunits = &nunits;  //NUMBER OF UNITS WITHIN SINGLE OSTINATO
	int *ptrnlines = &nlines;  //NUMBER OF LINES
	int *ptrnelem = &nelem;  //NUMBER OF ELEMENTS PER LINE WITHIN SINGLE OSTINATO
	int *ptrncurves = &ncurves; //Number of curves which will affect the overall shape of the piece
	
	string tempchar = "0";
	string *ptrtempchar = &tempchar; //char that retrieves the value from a string/char array CURRENTLY UNUSED

	float total_elem = 0;
	float total_dur = 0;
	float total_rep = 0;
	float tempo_elem = 0;
	float *ptr_total_elem = &total_elem;
	float *ptr_total_dur = &total_dur;
	float *ptr_total_rep = &total_rep;
	float *ptr_tempo_elem = &tempo_elem;

	/*
	if the score will be showing events in terms of their accents or events
	1 is for standard display
	2 is for accent display (numbers)
	3 is for custom display (stored in accent array)
	*/
	int displayevent = 1; //not implemented yet

	boolean balanced_units = false;
	boolean array_initialized = false;
	boolean boolreinit = false; //if the array needs to be reinitialized

	//random seed and multiplier stuff
	long rnd_seed = 0;
	float rnd_multiply = 0;
	long *ptr_rnd_seed = &rnd_seed;
	float *ptr_rnd_multiply = &rnd_multiply;


/*--------------------------------- end of GLOBAL stuff -------------------------------*/









/*---------------------Manipulation of the arrays(storing/retrieving)------------------*/
/*
array_no refers to the array it needs to retrieve the data from:

1. is for the "final_array" <char*> (or the array which is the resultant printer-ready array)

2. is for the "array" <int> (or the array which is the final template array, it has also all the separators and spacings in the place)

3. is for the "temparray" <int> (or the array that stores no. of elemenets within each unit)

4. is for the "curves" array <float> (or the array which contains the data about the curves that will
be applied to the overall structure affecting the probability)

5. is for the "accents" array <int> (or the array which stores the accent probability "spikes" for
the certain elements)

6. is for the "audible line" <int> array
*/


float retrieve(int ret_array_no, int ret_x, int ret_y)
	{

//	extern float array[10000][100];
//	extern int accent[10000][100];
//	extern float curves[6][500];
//	extern int temparray[5000][100];
//	extern string final_array[2][10000][100];
//	extern int hearlinearray[10000];
//	extern string *ptrtempchar;

	switch (ret_array_no)
		{
		case 1:
			*ptrtempchar = final_array[0][ret_x-1][ret_y-1];
			return 0;
			break;
		case 2:
			return array[ret_x-1][ret_y-1];
			break;
		case 3:
			return temparray[ret_x-1][ret_y-1];
			break;
		case 4:
			return curves[ret_x-1][ret_y-1];
			break;
		case 5:
			return accent[ret_x-1][ret_y-1];
			break;
		case 6:
			return hearlinearray[ret_x-1];
			break;
		}
	}
		
	
void storechar(int st_x, int st_y, string st_new_value)
	{	

//	extern string final_array[2][10000][100];

	final_array[0][st_x-1][st_y-1] = st_new_value;
	}



void storenum(int nm_array_no, int nm_x, int nm_y, float nm_new_value)
	{	

//	extern float array[10000][100];
//	extern int accent[10000][100];
//	extern float curves[6][500];
//	extern int temparray[5000][100];
//	extern int hearlinearray[10000];

	switch (nm_array_no)
		{
		case 2:
			array[nm_x-1][nm_y-1] = nm_new_value;
			break;
		case 3:
			temparray[nm_x-1][nm_y-1] = (int)nm_new_value;
			break;
		case 4:
			curves[nm_x-1][nm_y-1] = (int)nm_new_value;
			break;
		case 5:
			accent[nm_x-1][nm_y-1] = (int)nm_new_value;
			break;
		case 6:
			hearlinearray[nm_x-1] = (int)nm_new_value;
			break;
		}
	}

/*---------------------------- end of manipulation functions --------------------------*/





/*------------------------------- Input conversion tools ------------------------------*/

float numfloatinput () {

	string word;

	int num =0;
	int loop = 0;
	int outerloop = 0;
	int test = 0;
	int place = 0;

	boolean point, compute;
	float result, tens;

	tens = 1;
	result = 0;
	point = false;
	compute = false;


	cin >> word;
	num = word.size();


	for ( outerloop = 0; outerloop < num; outerloop++ )
	{
		test = word[outerloop];
		if ( test == 46 && point )
			{
			cout << "Error, invalid input! ";   // DEBUG << " " << test << " " << outerloop << endl;
			return -1;
			}
		if ( test == 46 && !point )
			{
			point = true;
			place = outerloop;
			//cout << "Found point at place: " << place << endl;    //DEBUG
			}
	}

	//cout << "Phew! Came this far!!!\n";   //DEBUG
	
	for ( outerloop = 0; outerloop < num; outerloop++ )
	{
		tens = 1;
 		test = word[outerloop];

		if ( test < 48 && outerloop != place && point || test > 57 && outerloop != place && point || test < 48 && !point || test > 57 && !point )
			{
			cout << "Error, invalid input! ";   // DEBUG << " " << test << " " << outerloop << endl;
			return -1;
			}

 		//cout << "digit " << outerloop << " = " << test << endl;	  //DEBUG	

			if ( outerloop > place && point ) {
				for (loop = outerloop ; loop > place ; loop-- )
					{
					tens = tens / 10;
					compute = true;
					}
				}
			if ( point && outerloop != place )
				{
				for (loop = outerloop ; loop < (place - 1) ; loop++ )
					{
					//if ( outerloop == (num - 1) && !point ) tens = 1;    //OBSOLETE
					tens = tens * 10;
					compute = true;
					}
				}
			if ( !point )
				{
				for (loop = outerloop ; loop < (num - 1) ; loop++ )
					{
					//if ( outerloop == (num - 1) && !point ) tens = 1;    //OBSOLETE
					tens = tens * 10;
					compute = true;
					}
				}
			if ( outerloop == (place - 1) && point || outerloop == (num -1 ) && !point ) { compute = true; }

	//cout << "Tenths = " << tens << endl;    //DEBUG
	
	if ( compute ) { 
		tens = tens * (test - 48);
		result = result + tens;
		//cout << "Computing...\n";    //DEBUG
		}

	//cout << tens << " end of a run\n";    //DEBUG
	
	compute = false;

	//cout << "Result = " << result << endl;   //DEBUG
	}
     	if (result == 0)
		{
		return 0;
		}
	return result;
	//cout << result;   //DEBUG
}







/*
//unused at this time, to be used by the parser...
float numfloat(string parser_word) {

	int parser_num = 0;
	int parser_loop = 0;
	int parser_outerloop = 0;
	int parser_test = 0;
	int parser_place = 0;
	boolean parser_point, parser_compute;
	float parser_result, parser_tens;

	parser_tens = 1;
	parser_result = 0;
	parser_point = false;
	parser_compute = false;	


	parser_num = strlen(parser_word);


	for ( parser_outerloop = 0; parser_outerloop < parser_num; parser_outerloop++ )
	{
		parser_test = parser_word[parser_outerloop];
		if ( parser_test == 46 && parser_point )
			{
			cout << "Error, invalid input! ";   // DEBUG << " " << test << " " << outerloop << endl;
			return 0;
			}
		if ( parser_test == 46 && !parser_point )
			{
			parser_point = true;
			parser_place = parser_outerloop;
			//cout << "Found point at place: " << place << endl;    //DEBUG
			}
	}

	//cout << "Phew! Came this far!!!\n";   //DEBUG
	
	for ( parser_outerloop = 0; parser_outerloop < parser_num; parser_outerloop++ )
	{
		parser_tens = 1;
 		parser_test = parser_word[parser_outerloop];

		if ( parser_test < 48 && parser_outerloop != parser_place && parser_point || parser_test > 57 && parser_outerloop != parser_place && parser_point || parser_test < 48 && !parser_point || parser_test > 57 && !parser_point )
			{
			cout << "Error, invalid input! ";   // DEBUG << " " << test << " " << outerloop << endl;
			return 0;
			}

 		//cout << "digit " << outerloop << " = " << test << endl;	  //DEBUG	

			if ( parser_outerloop > parser_place && parser_point ) {
				for (parser_loop = parser_outerloop ; parser_loop > parser_place ; parser_loop-- )
					{
					parser_tens = parser_tens / 10;
					parser_compute = true;
					}
				}
			if ( parser_point && parser_outerloop != parser_place )
				{
				for (parser_loop = parser_outerloop ; parser_loop < (parser_place - 1) ; parser_loop++ )
					{
					//if ( outerloop == (num - 1) && !point ) tens = 1;    //OBSOLETE
					parser_tens = parser_tens * 10;
					parser_compute = true;
					}
				}
			if ( !parser_point )
				{
				for (parser_loop = parser_outerloop ; parser_loop < (parser_num - 1) ; parser_loop++ )
					{
					//if ( outerloop == (num - 1) && !point ) tens = 1;    //OBSOLETE
					parser_tens = parser_tens * 10;
					parser_compute = true;
					}
				}
			if ( parser_outerloop == (parser_place - 1) && parser_point || parser_outerloop == (parser_num -1 ) && !parser_point ) { parser_compute = true; }

	//cout << "Tenths = " << tens << endl;    //DEBUG
	
	if ( parser_compute ) {
		parser_tens = parser_tens * (parser_test - 48);
		parser_result = parser_result + parser_tens;
		//cout << "Computing...\n";    //DEBUG
		}

	//cout << tens << " end of a run\n";    //DEBUG
	
	parser_compute = false;

	//cout << "Result = " << result << endl;   //DEBUG
	}

	return parser_result;
	//cout << result;   //DEBUG
}
*/

/*-------------------------end of INPUT MANIPULATION TOOLS ----------------------------*/










/*--------------------------------RANDOM NUMBER GENERATOR code ------------------------*/

/* Enhanced rand function borrowed from the RTcmix version 2.2 for linux */

float brrand(long brrandx)
{
	int i_number = ((brrandx = brrandx*1103515245 + 12345)>>16) & 077777;
	return((float)i_number/32768.0);
}



long getseed() {
	
//	extern long *ptr_rnd_seed;
	long getseedvalue;

	getseedvalue = 0;
	
	system("clear"); //CLEAR THE SCREEN

	while ( getseedvalue <= 0 ) {
		cout << "Enter random seed: ";
		getseedvalue = numfloatinput();
		}

	*ptr_rnd_seed = getseedvalue;
	return getseedvalue;
}




float getmultiplier()
	{
//	extern float *ptr_rnd_multiply;
	float fmultvalue;
	//char *word;

	fmultvalue = 0;

	system("clear"); //CLEAR THE SCREEN

	while ( fmultvalue < 1 ) {
		cout << "Enter value of the multiplier (can be decimal, but it MUST be equal or greater than 1): ";
		fmultvalue = numfloatinput();
		cout << fmultvalue; //DEBUG
		}
		
	*ptr_rnd_multiply = fmultvalue;
	return fmultvalue;
	}




void testrandom(long testseed,float testmultiplier, int testinstances)
	{
	int itest;
	float testrndnum;

	cout << "Following ten instances are a result of a given seed and multiplier:\n";
	for (itest = testseed; itest < (testseed+testinstances); itest++)
		{
		testrndnum = brrand(itest)*testmultiplier;
		while (testrndnum > 1) { testrndnum = testrndnum/10; }
		cout << testrndnum << endl;
		}
	}

/*-------------------------------- end of RANDOM NUMBER GENERATOR code-----------------*/















/*-------------------------------------------- HELP file ------------------------------*/


void help()
{
	char helppause;

	system("clear"); //CLEAR THE SCREEN

	cout << "SPiDSiG is distributed under the GNU GPL license v3 or newer.\n\n"
	     <<	"Author: Ivica Ico Bukvic <ico@bukvic.net>\n\n"
	     << "This help file is like a good portion of US expressways under permanent construction. In other words, it is safe to assume it will never be implemented. Thank you for reading...\n\nPress any key to return to the main menu...\n";

	cin >> helppause;
}

/*------------------------------------------- end of HELP file ------------------------*/

















/*------------------- Generic function for input of nlines and nunits -----------------*/



int linesunits(string info, string error, int limit)
{	
        int number;
	char confirm;
	
	
	number = 0;

	system("clear"); //CLEAR THE SCREEN

        while ( number <= 0 )
  		{
                cout << info;
  		number = numfloatinput();
  		//cout << "Entered number: " << number << endl ;   //DEBUG
		if ( number > 0 && number < limit )
			{
			cout << "Please confirm your value: " << number << " (Y/N)? ";
			cin >> confirm;
	            if ( confirm == 'y' || confirm == 'Y' )
				 {
				 return number;
				 }
				 else 
				 {
				 number = 0;
				 }
			}
		else
		    {
		    cout << error;
			number = 0;
			}
		}
}

/*------------------------- end of generic input function -----------------------------*/

















/*-------------------------- number of elements function ------------------------------*/


void nelements()
	{

//	extern int *ptrnlines, *ptrnunits, *ptrnelem;
//	extern boolean balanced_units;

	
	system("clear");

	//cout << *ptrnlines << " " << *ptrnunits;     //DEBUG
	char test;
	boolean evendistrib = false;
	boolean cutoff = false;
	int number, even, value, loop1, loop2, loop3, nunits, last, lastcheck;
	float evencheck, floatnumber, floatnunits, result;

	int matrixval = 0;
	int addcheck = 0;
	int oldeven = 0;
	
	nunits = *ptrnunits;
	last = 0;


	number = linesunits("Enter the TOTAL number of elements per line: ", "Invalid value! ", 100000);
	*ptrnelem = number;
	
	cout << "Will your distribution of elements be even throughout the units (valid for all lines) (Y/N)? ";
	cin >> test;
	if (test == 'y' || test == 'Y' ) 
		{ 
		evendistrib = true;
		even = number / nunits;
		if (even < 1) {even = 1;}
		floatnumber = number;
		floatnunits = nunits;
		evencheck = floatnumber / floatnunits;
		result = evencheck - even;
		balanced_units = true;
		
		//cout << "result =" << result << "  even =" << even << "evencheck =" << evencheck << endl;//DEBUG
		
		if (result > 0 )
			{
			last = number-(even*nunits)+even;
			if (last < 0) { last = 0; }
			matrixval = retrieve(3, last-1, 0);		
	
			if (last > matrixval && last-(nunits-1) > 0 )
				{
				last = last - (nunits-1);
				if ( last < 0 ) { last = 0; }
				
				even = even+1;
				}
			if (*ptrnelem > *ptrnunits)
				{
				cout << "Last unit will have " << last <<" units due to uneven distribution.\n";
				}
			}
			

		oldeven = even;
		//cout << "Oldeven = " << oldeven << " Even = " << even << endl; //DEBUG

		for (loop1 = 0; loop1 < *ptrnlines; loop1++) 
				{
				even = oldeven;
				addcheck = 0;
				//cout << "Even = " << even << endl; //DEBUG
				for (loop2 = 0; loop2 < *ptrnunits; loop2++) 
					{
					lastcheck = *ptrnunits-1;
					//cout << "lastcheck =" << lastcheck << " loop2 =" << loop2 << endl; //DEBUG
					if ( loop2 == lastcheck && last > 0 ) 
						 {
						 storenum(3, loop2, loop1, last);
						 //*(ptrtemparray+(loop1*nunits)+loop2) = last; //OBSOLETE WAY
						 //cout << "Last in effect! " << *(ptrtemparray+(loop1*nunits)+loop2) << endl;//DEBUG
						 }
					else 	{
						storenum(3, loop2, loop1, even);
						addcheck = addcheck + even;
						if (addcheck == *ptrnelem)
							{
							even = 0;
							last = 0;
							}
						//*(ptrtemparray+(loop1*nunits)+loop2) = even; //OBSOLETE WAY
						//cout << "Last is dormant... " << *(ptrtemparray+(loop1*nunits)+loop2) << endl;//DEBUG
						}
					}
				cout << "Your entered array for the line " << loop1+1 << " looks as follows:\n";
				for (loop3 = 0; loop3 < *ptrnunits; loop3++) 
					{
					//cout << loop3 << " is the unit no. " << loop1 << " is the line no. ";  //DEBUG
   					cout << retrieve(3, loop3, loop1);
					if (loop3 < *ptrnunits-1) { cout << "-";}
					//cout << *(ptrtemparray+(loop1*nunits)+loop3) << "-";  //OBSOLETE WAY
					}
				cout << endl;
				}
		cout << endl;
		}	
	else 	{
			cout << "All your input will be truncated to int value, as well as expanded or shrunk in order to fill all the empty elements slots.\n";
			result = 0;
			value = -1;
			balanced_units = false;
			for (loop1 = 0; loop1 < *ptrnlines; loop1++) 
				{
				for (loop2 = 0; loop2 < *ptrnunits; loop2++) 
					{
					if (!cutoff) 
						{
						cout << "Enter number of elements in the " << loop1+1 << ". line, " << loop2+1 << ". unit:";

					 	while (value < 0)
					 		 {
					 		 //cout << "Input function accessed!\n"; //DEBUG
					 		 value = numfloatinput(); 
					 		 }

						storenum(3, loop2, loop1, value);
						
					 	//*(ptrtemparray+(loop1*nunits)+loop2) = value; //OBSOLETE WAY
					 	//cout << "Value at " << loop1+1 << " " << loop2+1 << " is " << *(ptrtemparray+(loop1*nunits)+loop2) << endl;    //DEBUG
					 	}
					else 	{
						//*(ptrtemparray+(loop1*nunits)+loop2) = 0; //OBSOLETE WAY
						value = 0;
						storenum(3, loop2, loop1, value);
						}
					result = result + value;
					if (result >= number && !cutoff)
						{
						last = value-(result-number);
						storenum(3, loop2, loop1, last);

						//*(ptrtemparray+(loop1*nunits)+loop2) = last;  //OBSOLETE WAY
						
						cutoff = true;
						}
					if (result < number && loop2 == (nunits-1))
						{
						value = value + (number - result);

						storenum(3, loop2, loop1, value);				

						//*(ptrtemparray+(loop1*nunits)+loop2) = value;  //OBSOLETE WAY
						}
					 value = -1;	
					}
				cout << "Your entered array for the line " << loop1+1 << " looks as follows:\n";
				for (loop3 = 0; loop3 < *ptrnunits; loop3++) 
					{
					
					cout << retrieve(3 ,loop3 ,loop1);
					if (loop3 < *ptrnunits-1) { cout << "-";}
					//cout << *(ptrtemparray+(loop1*nunits)+loop3) << " ";  //OBSOLETE WAY
					}
				cout << endl;
				result = 0;
				cutoff = false;
				}
		cout << endl;
		}
	}

/*------------------- end of number of elements input function ------------------------*/

























/*---------------------------- accents and elements editing tool ----------------------*/

int editarray(int arrayname)
	{
	
	
//	extern int *ptrnlines, *ptrnunits, *ptrnelem, *ptraccent;

	int line, unit, newelem, difference, loop3, globnelem, globnunit, accentloop, accentinput;
	char test;
	boolean lineinit = false;

	
	system("clear");


	line = 0;
	difference = 0;
	globnelem = *ptrnelem;
	globnunit = *ptrnunits;

	
	cout << "Please be aware that if you chose to make any changes, your probability array will have to be reinitialized.\n";
	
	
	

	
	while (line >= 0)
		{
		cout << "Press [N] to enter line number you wish to edit, or press any other key to exit: ";
		cin >> test;
		if (test == 'n' || test == 'N' )
			{
			switch(arrayname)
				{
				case 3:
					cout << "Enter the line you wish to edit: ";
					while (line <= 0 || line > *ptrnlines)
						{
						line = numfloatinput();
						if (line > *ptrnlines) { cout << "Please enter a number within the boundaries of the existing number of lines! "; }
						}
					break;
				case 5:
					cout << "Enter the accent level you wish to edit: ";
					while (line <= 0 || line > *ptraccent)
						{
						line = numfloatinput();
						if (line <= 0 || line > *ptraccent) { cout << "Please enter a number within the boundaries of the existing number of lines! "; }
						}
					break;
				}




			if (arrayname == 5)
				{
				accentinput = retrieve(5, 1, line-1);
				if (accentinput == 0)
					{
					cout << "Given line has an accent of " << retrieve(5, 0, line-1) << "% applicable to ALL lines.\n";
					}
				else	{
					cout << "Given line has an accent of " << retrieve(5, 0, line-1) << "% applicable to line no. " << accentinput << ".\n";
					}
				
				for (accentloop = 2; accentloop < (*ptrnelem+2); accentloop++)
					{
					if (retrieve(5, accentloop, line -1) > 0)
						{
						lineinit = true;
						}
					}
				if (!lineinit)
					{
					cout << "No elements of this accent level bear the accented value.\n";
					}
				else	{
					cout << "Elements no. ";
					for (accentloop = 2; accentloop < (*ptrnelem+2); accentloop++)
						{
						//cout << "Searching " << accentloop << ", " << line-1 << endl; //DEBUG
						if ((retrieve(5, accentloop, line-1)) == 1)
							{
							//cout << "Found event at " << accentloop << "," << line-1 << endl; //DEBUG
							cout << (accentloop-1) << ", ";
							}
						}
					cout << "are currently designated as having this accent.\n";
					}
				cout << "Press 1 to edit accentuation value of this accentuation line or press 2 to continue: ";
				accentinput = -1;
				while (accentinput < 1 || accentinput > 2)
					{
					accentinput = numfloatinput();
					}
				if (accentinput == 1)
					{
					cout << "Old accentuation value for this accentuation level is " << retrieve(5, 0, line-1) << "%. Enter new value between 0% and 999%: ";
					accentinput = -1;
					while (accentinput < 0 || accentinput > 999)
						{
						accentinput = numfloatinput();
						if (accentinput < 0 || accentinput > 999)
							{
							cout << "Invalid value! Please enter again: ";
							}
						storenum(5, 0, line-1, accentinput);
						}
					cout << "Your new value is " << accentinput << "%.\n";
					}
				cout << "Press 1 to edit number of line(s) to which this level applies or press 2 to continue: ";
				accentinput = -1;
				while (accentinput < 1 || accentinput > 2)
					{
					accentinput = numfloatinput();
					}
				if (accentinput == 1)
					{
					if ( (retrieve(5, 1, line-1)) == 0)
						{
						cout << "Old value applied to ALL lines. Enter new value for the applicable line: ";
						}
					else	{
						cout << "Old value applied to " << retrieve(5, 1, line-1) << ". line. Enter new value for the applicable line (0 is for all): ";
						}

					accentinput = -1;
					while (accentinput < 0 || accentinput > *ptrnlines)
						{
						accentinput = numfloatinput();
						if (accentinput < 0 || accentinput > *ptrnlines)
							{
							cout << "Invalid value! Please enter again: ";
							}
					//STORING OF THE APPLICABLE LINE IS INCREASED BY 1 DUE TO FACT THAT 0 IS RESERVED FOR "ALL LINE" ACCENTUATION
						storenum(5, 1, line-1, accentinput);
						}
					if (accentinput == 0)
						cout << "Your new value is applicable to all lines.\n";
					else
						cout << "Your new value is " << accentinput << ".\n";
					}
				}

			newelem = -1;
			switch(arrayname)
				{
				case 3:
					cout << "Enter the unit you wish to edit: ";
					unit = -1;
					while (unit < 1 || (unit+1) > globnunit)
						{
						unit = numfloatinput();
						if (unit > globnunit) { cout << "Please enter a number within the boundaries of the given number of units! "; }
						}
					cout << "Current value at the line no. " << line << " and unit no. " << unit << " is: " << retrieve(arrayname, unit-1, line-1) << endl;
					cout << "Enter the new value: ";
					newelem = -1;
					while (newelem < 0) { newelem = numfloatinput(); }
					difference = difference + retrieve(arrayname, unit-1, line-1) - newelem;
					storenum(arrayname, unit-1, line-1, newelem);
					break;
				case 5:
					while (unit != 0)
						{
						cout << "Enter the element you wish to edit or press 0 to exit: ";
						unit = -1;
						while (unit < 0 || unit > globnelem)
							{
							unit = numfloatinput();
							if (unit > globnelem) { cout << "Please enter a number within the boundaries of the given number of elements! "; }
							}
						if (unit != 0)
							{
							cout << "Current value at the accent level no. " << line << " and element no. " << unit << " is: " << retrieve(arrayname, unit+1, line-1)  << endl;

							cout << "Enter the new value (press 1 for accentuation level or 0 for no accentuation level): ";
							newelem = -1;
							while (newelem < 0 || newelem > 1) { newelem = numfloatinput(); }
							if (newelem == 0 || newelem == 1)
								{
								storenum(arrayname, unit+1, line-1, newelem);
								}
							if (newelem == 1)
								{
								cout << "Element no. " << unit << " now has accentuation applied to it.\n";
								}
							else if (newelem == 0)
								{
								cout << "Element no. " << unit << " now has accentuation disabled.\n";
								}
							}
						else 	{
							cout << "Completed editing this line...\n";
							}
						}
					break;
				}


			//cout << "Value in the array is: " << *(ptrtemparray+((line-1)*globnelem)+(unit-1)) << endl; //DEBUG
			//cout << "newelem = " << newelem;  //DEBUG

			//difference = difference + (*(ptrtemparray+((line-1)*globnelem)+(unit-1)) - newelem);//OBSOLETE
			//*(ptrtemparray+((line-1)*globnelem)+(unit-1)) = newelem; //OBSOLETE
		
			while (difference != 0) 
				{
				cout << "You have a deviation of " << difference << " within this line. In order to complete this process, please compensate for the difference. Enter the unit number to be adjusted: ";
				unit = 0;
				while (unit <= 0 || unit > globnelem)
					{ 
					unit = numfloatinput(); 
					if (unit > globnelem) { cout << "Please enter a number within the boundaries of the given number of units! "; }
					}
				//cout << "Current value at the line no. " << line << " and unit no. " << unit << " is: " << *(ptrtemparray+((line-1)*globnelem)+(unit-1)) << endl; //OBSOLETE

				cout << "Current value at the line no. " << line << " and unit no. " << unit << " is: " << retrieve(arrayname, unit-1, line-1) << endl; 				
 				cout << "Enter the new value: ";
				newelem = 0;
				while (newelem <= 0) { newelem = numfloatinput(); }

				difference = difference + retrieve(arrayname, unit-1, line-1) - newelem;
				storenum(arrayname, unit-1, line-1, newelem);

				//difference = difference + (*(ptrtemparray+((line-1)*globnelem)+(unit-1)) - newelem);//OBSOLETE
				//*(ptrtemparray+((line-1)*globnelem)+(unit-1)) = newelem; //OBSOLETE
				}
			switch(arrayname)
				{
				case 3:
					cout << "Your newly entered array for the line " << line << " looks as follows:\n";
					for (loop3 = 0; loop3 < *ptrnunits; loop3++)
						{	
						cout << retrieve(arrayname, loop3, line-1);
						if (loop3 < *ptrnunits-1) { cout << "-";}
						}
					break;
				case 5:
					cout << "Your newly entered array for the accent level " << line << " looks as follows:\n";
					for (loop3 = 0; loop3 < (*ptrnelem+2); loop3++)
						{
						if (loop3 == 0)
							{
							cout << "Level=" << retrieve(arrayname, loop3, line-1) << "%, ";
							}
						if (loop3 == 1)
							{
							if ( retrieve(arrayname, loop3, line-1) == 0 )
								{
								cout << "ALL lines, and includes element(s): ";
								}
							else
								{
								cout << "Line " << retrieve(arrayname, loop3, line-1) << ", and includes element(s): ";	
								}
							}	
						if (loop3 > 1)
							{
							if (retrieve(arrayname, loop3, line-1) == 1)
								{
								cout << loop3 - 1 << " ";
								}
							}
						}
					break;
				}
				//cout << *(ptrtemparray+((line-1)*globnelem)+loop3) << "-"; //OBSOLETE
			cout << endl;
			cout << endl;
			}
		else	{ return 0; }
		}
	}
		
/*---------------------- end of accents and elements editing tool ---------------------*/












/*------------------------ Initialization of the "array" array ------------------------*/
/* "array" stores following information:
"1" for a "|" sign
"2" for a "|:" sign
"3" for empty space which alligns with other line's "|"
"element no.+probability" for an event i.e. 3073 is for element no.3 with probability of 73%
*/



void respacebars(int limit)
	{

//	extern int *ptrnelem, *ptrnunits, *ptrnlines, *ptr_array_nelem;
//	extern float *ptr_total_dur, *ptr_total_rep, *ptr_tempo_elem, *ptr_total_elem;

	int xr, yr, maxlimit, ymaxlimit, counter, swapval1, swapval2, xcurr, x_loop2;	
	
	counter = maxlimit = ymaxlimit = 0;
	//cout << "Respacebars function says: limit = " << limit << endl; //DEBUG

//CHECKING HIGHEST POSITION OF THE DOUBLE BAR
	for (yr = 0; yr < *ptrnlines; yr++) //loop through all LINES
		{
		counter = 0; //counter of double bars, it checks how many bars have been encountered and compares it to the given limit
		for (xr = 0; xr <= *ptr_array_nelem; xr++)
			{
			if ( retrieve(2, xr, yr) == 2 ) //if current element is equal to 2 or the "|:" double bar sign
				{
				//cout << "Value of the array at " << x << "," << y << " is " << retrieve(2, x, y) << ". Thus the counter is increased...\n"; //DEBUG
				counter++; //encountered a double bar, thus counter is incremented

				if ( counter == limit ) //if counter and limit are the same, then it must be the barline that needs to be respaced
					{
					if (maxlimit < xr) //if maxlimit (or the max position of this barline is lesser than the position if the current line, then equalize them
						{
						maxlimit = xr;
						ymaxlimit = yr;
						//cout << "Respacebars function says: maxlimit increased to " << maxlimit << endl << " because counter " << counter << " is equal to limit " << limit << endl; //DEBUG
						}
					}
				}
			}
		}

//RESPACING DOUBLE BAR

	for (yr = 0; yr < *ptrnlines; yr++)  //SETTING UP y LOOP FOR THE LOOPING THROUGH ALL THE LINES
		{
		counter = 0; //resetting the counter for each line (and from the first part of this function)
		for (xr = 0; xr < *ptr_array_nelem; xr++)   //SETTING UP x LOOP FOR THE LOOPING WITHIN EACH LINE
			{
			if ( retrieve(2 ,xr, yr) == 2)
				{
				counter++;
				//cout << "Respacebar found a pipe at " << x << "," << y << endl; //DEBUG
				if (counter == limit)
					{
					if ( xr < maxlimit)
						{
						//cout << "Line " << y << " has a pipe wrongly positioned...\n"; //DEBUG
						//cout << " PTR_ARRAY_NELEM = " << *ptr_array_nelem << endl; //DEBUG
						xcurr = xr;
						while (xcurr < maxlimit)
							{
							//cout << "Xcurr = " << xcurr << endl; //DEBUG
							for (x_loop2 = xcurr; x_loop2 < *ptr_array_nelem; x_loop2++)
								{
								//cout << "xloop2 = " << x_loop2 << " PTR_ARRAY_NELEM = " << *ptr_array_nelem << endl; //DEBUG
								if (x_loop2 == xcurr)
									{
									//cout << "Respacebars function says : First element at " << xcurr; //DEBUG
									swapval2 = retrieve(2, x_loop2, yr);
									storenum(2, xcurr, yr, 3);
									//cout << "value at this point is now set to: " << retrieve(2, xcurr, y) << endl; //DEBUG
									*ptr_array_nelem = *ptr_array_nelem + 1;
									}
								else if (x_loop2 > xcurr)
									{
									//cout << "* xloop2 = " << x_loop2 << " and value stored at this point is" << swapval2; //DEBUG
									swapval1 = retrieve(2, x_loop2, yr);
									storenum(2, x_loop2, yr, swapval2);
									swapval2 = swapval1;
									}
								}
							xcurr++;
							}
						}
					}
				}
			}
		}
	}					



void initarray()
	{

	int x, y, tempx, tempy, nreploop, counter3, counter4, element_id, y_loop, x_loop, xmax, xcurr, testval, testval2, orderno, orderno2;
	int last_rep_elem, last_rep_run, testloop, n_units, nrep, xincrement, xelem, x_loop2;
	int elem_in_cur_unit, swapval1, swapval2;
	float diff_nrep;
	boolean lastrun, endbar, accentvisited;
	float input_value, debug_val;
	int limit;
	int accentuation, tempadjust, y_accent, temptotalelem, templastelem, tempcounter;
	
//	extern boolean balanced_units, array_initialized;
//	extern int *ptrnelem, *ptrnunits, *ptrnlines, *ptr_array_nelem, *ptraccent, *ptrlastrep;
//	extern float *ptr_total_dur, *ptr_total_rep, *ptr_tempo_elem, *ptr_total_elem;

//	extern string *ptrtempchar;   //DEBUG

	lastrun = false;
	last_rep_run = 0;
	element_id = 1;
	last_rep_run = 0;

	nrep = *ptr_total_rep;
	if (balanced_units)  //only if there is no polymetric stuff can the last ostinato be incomplete, rounded to the nearest unit
		{
		diff_nrep = *ptr_total_rep - nrep;
		last_rep_elem = (*ptrnelem * diff_nrep) + 0.5; //plus 0.5 because it needs to round up
		for (testloop = 0; testloop < *ptrnunits; testloop++)
			{
			last_rep_elem = last_rep_elem - retrieve(3, testloop, 0);
			if (last_rep_elem >= 0)
				{
				last_rep_run++;  //number of units in the last partial repetition
				//cout << "lastreprun = " << last_rep_run; //DEBUG
				}
			}
		if (last_rep_run > 0)  //if last repetition has more than 0 units then, the number of repetitions is increased by one
			{
			*ptrlastrep = last_rep_run;
			nrep++;
			lastrun = true;
			templastelem = 0;
			for (tempcounter = 0; tempcounter < *ptrlastrep; tempcounter++)
				{
				templastelem = templastelem + retrieve(3, tempcounter, 0);
				}
			temptotalelem = ((int)(*ptr_total_rep) * (*ptrnelem)) + templastelem;
			if (temptotalelem < *ptr_total_elem) //after deciding how many elements there are in the last incomplete rep, make sure that is the proper total number of elements
				{
				*ptr_total_elem = temptotalelem;
				}
			cout << "\nYour last repetition will have " << last_rep_run << " units, and thus the whole piece will have a total of " << *ptr_total_elem << " elements. Please make a note of it!\n";
			}
		if (last_rep_run == 0 && diff_nrep != 0)
			{
			cout << "\nYour last incomplete repetition did not have enough elements even for a single unit, thus there will be no incomplete repetition initialized.\n";
			}
		}
	*ptr_array_nelem = ((*ptrnelem) + 2 + (*ptrnunits)) * nrep;
	//NUMBER OF SPACES I NA A WHOLE ARRAY (INCLUDING BARLINES!!!) IS EQUAL TO NUMBER OF ELEMENTS + OPENING AND ENDING BARLINES + NUMBER OF UNITS (THEREFORE INNER BARLINES) * REPETITIONS

//Storing of the unit groups for all lines with accentuation probabilities, or if they don't exist, with 100% probabilities

	for (y = 0; y < *ptrnlines; y++)
		{
		x = 0;
		element_id = 1;
		storenum(2, x, y, 1);  //storing of the first single barline
		x++;

		for (nreploop = 0; nreploop < nrep; nreploop++)  //checking for completeness of the last repetition
			{
			if (nreploop == nrep-1 && lastrun)
				{
				n_units = last_rep_run;
				//cout << "This task will involve incomplete last repeat...\n"; //DEBUG
				}
			else	{
				n_units = *ptrnunits;
				//cout << "This task does not have any incomplete cells...\n"; //DEBUG
				}	

			//BEGINING OF THE INITIALIZATION
			for (counter3 = 0; counter3 < n_units; counter3++)
				{
				storenum(2, x, y, 1); //EVERY UNIT STARTS WITH A BARLINE
				x++;
				//cout << "Retrieving unit " << counter3 << endl; //DEBUG

				elem_in_cur_unit = retrieve(3, counter3, y);

				for (counter4 = 0; counter4 < elem_in_cur_unit; counter4++)
					{
					accentvisited = false; //resetting the accent checking routine
					if (*ptraccent == 0)  //if there are no levels of accentuation initialized
						{
						input_value = ((element_id) * 1000) + 100;
						storenum(2, x, y, input_value);
						element_id++; //increasing id number of the element
						x++; //increasing the position in the array
						}
					else	{  //if accentuation lines do exist do the following:
						for (y_accent = 0; y_accent < *ptraccent; y_accent++)
							{
							xincrement = element_id+1; //this is because the first id number (zero) is unused due to fact if I were to use it and the 0th element had probability less than 3, it would be misplaced for a barline
							while ( xincrement > *ptrnelem+1) //thus I have to compare for the ptrnelem + 1 due to fact xincrement has been incremented by one
								{
								xincrement = xincrement - *ptrnelem;
								}

							//HAVE TO COMPARE WITH y+1 BECAUSE ACCENTUATION LINE IS STORED FROM 1 TO NLINES, DUE TO FACT 0 IS RESERVED FOR "ALL LINE ACCENTUATION"
							if ( (retrieve(5,xincrement,y_accent)) == 1 && (retrieve(5,1,y_accent)) == (y+1) )
								{
								//cout << "Entering individual line accent\n"; //DEBUG
								//ACCENTUATION BASED ON INDIVIDUAL LINES TAKES PRESEDENCE, THUS I USE accentvisited VARIABLE IN ORDER TO TRACK THIS
								accentuation = retrieve(5,0,y_accent);
								accentvisited = true;
								}
							else if ( (retrieve(5,xincrement,y_accent)) == 1 && (retrieve(5,1,y_accent)) == 0 && !accentvisited )
								{
								//cout << "Entering multiple line accent\n"; //DEBUG
								accentuation = retrieve(5,0,y_accent);
								accentvisited = true;
								}
							else if (!accentvisited)
								{
								//IF NO ACCENTUATION GIVEN
								//cout << "No accentuation given for this element...\n"; //DEBUG
								accentuation = 100;
								}
							}
						input_value = ((element_id) * 1000) + accentuation;  //Storing the accentuated value
						storenum(2, x, y, input_value);
						element_id++; //increasing the id number of the element
						x++; //increasing the position in the array
						}
					}
				}

			storenum(2, x, y, 2); //IMPORTANT! store the double bar "|:" at the end of the OSTINATO FIGURE
			x++; //increase the position in the array
			//cout << "Finished cycle " << nreploop << " in line " << y << endl;
			}
		}


//Respacing values in the case of poly-metric lines in order to accomodate for unit separators
//PART 1: getting the max position of current element

	xmax = orderno = testval = testval2 = xcurr = limit = 0;
	endbar = false;

		if (!balanced_units) //Do this only in the case of polymetric line
			{
			for (xelem = 0; xelem <= *ptr_total_elem; xelem++) //Do this for ALL elements in ALL repetition groups
				{
				//cout << "Xelem = " << xelem << " flag for bar respacing is at " << ((*ptrnelem) + ( (*ptrnelem) * limit )) << endl; //DEBUG
				//cout << "Ptrnelem = " << *ptrnelem << " Ptrnelem * 0 = " << *ptrnelem * 0 << endl; //DEBUG

				xmax = 0; //IMPORTANT!!! resetting maxposition of the current element for the next run

				//cout << "Searching for orderno = " << xelem << endl; //DEBUG
				for (y_loop = 0; y_loop < *ptrnlines; y_loop++)
					{
					//cout << "Start of line " << y_loop << endl; //DEBUG
					for (x_loop = 0; x_loop < *ptr_array_nelem; x_loop++)
						{
						testval = retrieve(2, x_loop, y_loop);  //getting the contents of the current element
			
						if (testval > 3 /*&& testval != 100*/) //comparing the contents to see if it is an element, rather than a barline, or something else
							{
							orderno = (int)(testval/1000);  //getting the value of the id number of the current element
							//cout << "No. " << orderno << " testval = " << testval << " elem.no. = " << x_loop <<endl;
							}

						if (orderno == xelem && x_loop > xmax && testval > 3) //If some element is ahead of the other, then set the max position forward so that other can be pushed ahead in order to be alligned
							{
							//cout << "xmax has been changed to " << x_loop << endl; //DEBUG
							xmax = x_loop;
							}
						}
					}
									
				//cout << "Highest position of no. " << xelem << " is " << xmax << endl; //DEBUG
				//PART 2: Respacing other lines as needed in order to allign all elements of all lines with the same id number					

				for (y_loop = 0; y_loop < *ptrnlines; y_loop++)
					{
					xcurr = 0; //resetting the current position of the element in the current line

					for (x_loop = 0; x_loop < *ptr_array_nelem; x_loop++) //Do this for all elements within the confines of this array
						{
						testval2 = retrieve(2, x_loop, y_loop); //test the value in order to find where is current id number stored
						//if (testval2 == 100)
						//	{
						//	orderno2 = 0;
						//	}
						if (testval2 > 3 /*&& testval != 100*/)
							{
							orderno2 = (int)(testval2/1000);
							}
						if (orderno2 == xelem && testval2 > 3)
							{
							xcurr = x_loop; //save current position as the position of this element in this line
							}
						}

					//cout << "Current line " << y_loop << " has xcurr of " << xcurr << endl; //DEBUG

					while( xcurr < xmax ) //if current element position is lesser than the one found to be the greatest, do the respacing
						{
						for (x_loop2 = xcurr; x_loop2 < *ptr_array_nelem; x_loop2++) //push all elements one place forward with insertion of the "." (id = 3)
							{
							//cout << "Xloop2 = " << x_loop2 << " *ptr_array_nelem = " << *ptr_array_nelem << endl;
							if (x_loop2 == xcurr)
								{
								//cout << "First element"; //DEBUG
								swapval2 = retrieve(2, x_loop2, y_loop);
								storenum(2, xcurr, y_loop, 3); //insert "." or the space
								*ptr_array_nelem = *ptr_array_nelem + 1; //SIZE OF THE ELEMENT HAS JUST CHANGED DUE TO INSERTION OF THE SPACE
								}
							else
								{
								//cout << "*"; //DEBUG
								swapval1 = retrieve(2, x_loop2, y_loop);
								storenum(2, x_loop2, y_loop, swapval2);
								swapval2 = swapval1;
								}
							}
							xcurr++;
						}
					}
				if (xelem+1 > ((*ptrnelem) + ( (*ptrnelem) * limit )) )
				//because xelem starts with 0, if it has added 2, and reaches the end of the ostinato group, it MUST be greater than the no. of elements in that group
				//thus the respacing of the double bar is called
					{
					limit++; //limit denotes which repetition group is being worked on

					respacebars(limit); //RESPACE DOUBLE BAR function is called
					}
				}
			}

	cout 	<< "\nCompleted.\n"
		<< "Would you like to check template data? (Y/N) ";

	char templatedata;

	cin >> templatedata;

	if (templatedata == 'y' || templatedata == 'Y')
		{
		for (tempy = 0; tempy < (*ptrnlines); tempy++)
			{
			cout << "\nAccessing line " << tempy+1 << endl; //DEBUG
			for (tempx = 0; tempx < *ptr_array_nelem ; tempx++)
				{
				debug_val = retrieve(2, tempx, tempy);
				if (debug_val < 10)
					{
					if (debug_val == 1) {cout << "| ";}
					if (debug_val == 2) {cout << "|:";}
					if (debug_val == 3) {cout << ". ";}
					}
				else	{
					tempadjust = ( debug_val - ( ( (int)(debug_val/1000) )* 1000 ) );
					if (tempadjust < 10)
						{
						cout <<	(int)((debug_val)/1000) << "-00" << tempadjust << " ";
						}
					if (tempadjust >= 10 && tempadjust < 100)
						{
						cout <<	(int)((debug_val)/1000) << "-0" << tempadjust << " ";
						}
					if (tempadjust >= 100)
						{
						cout <<	(int)((debug_val)/1000) << "-" << tempadjust << " ";
						}
					}
				}
			cout << endl;
			}
		}

	cout << endl; //DEBUG

	array_initialized = true;
	}


/*-------------------- end of initialization of the "array" array ---------------------*/	











/*------------------------ Duration & repetition function -----------------------------*/


int durrep()
	{
//	extern float *ptr_total_dur, *ptr_total_rep, *ptr_tempo_elem;
//	extern float *ptr_total_elem;
//	extern boolean balanced_units;

	float convert;
	boolean calculate, durnum, durdur, durtmp;
	char test, dummy;
	int test_nrep_int, test_total_elem;

	*ptr_total_dur = *ptr_total_rep = *ptr_tempo_elem = 0;
	durnum = durdur = durtmp = calculate = false;
	convert = 0;

 	while (!calculate)
		{
		system("clear"); //CLEAR THE SCREEN
		test = '0';
		cout << "Please specify the duration by choosing one of the following:\n";
		cout << endl;
		cout << "t[E]mpo conversion tool\n";
		cout << endl;
		cout << "Specify duration by submitting (need TEMPO and one of the other two):\n";
		cout << endl;
		cout << "[D]uration in seconds\n";  		
		cout << "[N]umber of repetitions of the ostinato cell\n";
		cout << "[T]empo stating a duration of a single element\n";
		cout << endl;
		cout << "[C]alculate duration\n";
		cout << "e[X]it\n";
 		cout << endl;
		cin >> test;
		if (test == 'e' || test == 'E' )
			{
			convert = 0;
			system("clear"); //CLEAR THE SCREEN
			cout << "Specify tempo in musical terms i.e. element=120, meaning one element per 1/2 of second: ";
			while (convert <= 0) { convert = numfloatinput(); }
			cout << "The value you should enter as your [T]empo is " << 60/convert << " seconds per element.\n";
			cout << "Would you like this value as your tempo value? (Y/N) ";
			test = '0';
			cin >> test;
			if (test == 'y' || test == 'Y')
				{
				*ptr_tempo_elem = 60/convert;
				durtmp = true;
				cout << "Completed. Your tempo setting is " << *ptr_tempo_elem << " seconds per element.\n";
				}
			test = '0';
			cout << "Press any key to continue...";
			cin >> dummy;					
			}
 		if (test == 'd' || test == 'D' )
			{
			system("clear"); //CLEAR THE SCREEN
			*ptr_total_dur = 0;
			cout << "Specify duration of the piece in seconds: ";
			while (*ptr_total_dur <= 0) { *ptr_total_dur = numfloatinput(); }
			durdur = true;
			}
		if (test == 'n' || test == 'N' )
			{
			system("clear"); //CLEAR THE SCREEN
			*ptr_total_rep = 0;
			cout << "Specify number of the repetitions of the Line: ";
			while (*ptr_total_rep <= 0) { *ptr_total_rep = numfloatinput(); }
			durnum = true;
			}
		if (test == 't' || test == 'T' )
			{
			system("clear"); //CLEAR THE SCREEN
			*ptr_tempo_elem = 0;
			cout << "Specify the tempo of the single element by stating duration in seconds: ";
			while (*ptr_tempo_elem <= 0) { *ptr_tempo_elem = numfloatinput(); }
			durtmp = true;
			}
		if (test == 'x' || test == 'X' )
			{
			if (!calculate) { cout << "Your tempo and duration settings, and therefore your template array, have not been initialized properly...\n"; }
			return 0;
			}
		if (test == 'c' || test == 'C' )
			{
			system("clear"); //CLEAR THE SCREEN
			calculate = false;
			if (durdur && durtmp)
				{
				*ptr_total_elem = *ptr_total_dur / *ptr_tempo_elem;
				*ptr_total_elem = (int)(*ptr_total_elem);
				*ptr_total_rep=(*ptr_total_elem)/(*ptrnelem);
				//cout << "Nelem = " << *ptrnelem << " Total_elem = " << *ptr_total_elem << " Total_rep = " << *ptr_total_rep << endl; //DEBUG
				calculate = true;
				}
			else if (durnum && durtmp)
				{
				*ptr_total_elem = (*ptrnelem)*(*ptr_total_rep);
				*ptr_total_elem = (int)(*ptr_total_elem);
				*ptr_total_dur = (*ptr_total_elem)*(*ptr_tempo_elem);
				calculate = true;
				}
			else 	{
				cout << "You need at least TEMPO and another valid declaration before you can calculate all the parameters! "
				     << "Press [C] to continue...\n";
				cin >> dummy;
				}
				
			if (calculate)
				{
				cout << "Your tempo is " << *ptr_tempo_elem << " seconds per element and your tempo marking is ELEMENT = " << (int)( 60/(*ptr_tempo_elem) + .5 ) << ".\n";
				cout << "Your total number of elements is " << *ptr_total_elem << ".\n";
				cout << "The duration of a single cell is " << (float)(*ptrnelem * *ptr_tempo_elem) << " seconds.\n";
				cout << "The total duration of the piece is " << *ptr_total_dur << " seconds.\n";
				cout << "The total number of repetitions of the cell is " << *ptr_total_rep << ".\n";

				test_nrep_int = *ptr_total_rep;
				if (test_nrep_int != *ptr_total_rep)
					{
					if (balanced_units)
						{
						cout << "\nPlease note that since your number of repetitions is a decimal number, it will be truncated to the nearest UNIT since all your lines are sharing the same order of number of elements!\n";
  						}
					else	{
						cout << "\nYour units are poly-rhythmic, thus the number of repetitions will be truncated to the nearest lower integer...\n";
						}
					}
				if (*ptr_total_elem < *ptrnelem)
					{
					cout << "\nYour total number of elements is lesser than a SINGLE complete cell, thus your values will be changed as follows:\n";
					*ptr_total_elem = *ptrnelem;
					cout << "Your total number of elements is " << *ptr_total_elem << ".\n";
					*ptr_total_dur = (*ptr_total_elem)*(*ptr_tempo_elem);
					cout << "Your NEW total duration of the piece is " << *ptr_total_dur << " seconds.\n";
					*ptr_total_rep = 1;
					cout << "Your total number of repetitions of the cell is " << *ptr_total_rep << ".\n";
					}
				initarray();
				return 0;
				}
			}
	 	}
	}

/*-------------------------- end of duration & repetition function --------------------*/










/*-------------------------- accent entering function ---------------------------------*/

void accentinit()
	{
	system("clear"); //CLEAR THE SCREEN	

//	extern int *ptrnelem, *ptraccent, *ptrnlines;
//	extern boolean array_initialized;
	boolean anyelement;
	int test, nlevels, loop, loop2, input;

	test = -1;
	input = -1;
	nlevels = -1;
	anyelement = false;


//ERASING OLD DATA
	if (*ptraccent != 0)
		{
		cout << "Wiping out old data, please wait...";
		for (loop = 0; loop < *ptrnlines; loop++)
			{
			for (loop2 = 0; loop2 < *ptrnelem; loop2++)
				{
				storenum(5,loop2, loop, 0);
				}
			}
		cout << "Done.\n";
		}

	cout << "Please enter the number of levels of accentuation: ";
	while (nlevels < 0)
		{	
		nlevels = numfloatinput();
		if ( nlevels < 0 )
			{
			cout << "Oops! Invalid value, please enter again: ";
			}
		}

	if (nlevels == 0)
		{
		cout << "No levels to be initialized...";
		}

	else
		{

		for ( loop = 0; loop < nlevels; loop++)
			{
			input = -1;

			cout << "Please enter the integer accentuation level in % for the " << loop+1 << ". line of accentuation (limit between 0% and 999%): ";

			while( input < 0 || input >= 1000 )
				{
				input = numfloatinput();
				if (input < 0 || input >= 1000)
					{
					cout << "Invalid value! Please enter again: ";
					}
				}

			//Storing the value of the current level of accentuation as given number, meaning, it will NEED to be DIVIDED by 100 LATER!!!
			storenum(5, 0, loop,input);

			input = -1;

			cout << "Now, please enter the number of the LINE this accentuation level will be applicable to (if you want to make it applicable to ALL lines, enter 0, individual-line-accentuations take presedence over the multiple-line ones): ";

			while( input < 0 || input > *ptrnlines)
				{
				input = numfloatinput();
				if (input < 0 || input > *ptrnlines)
					{
					cout << "Invalid value! Please enter again: ";
					}
				}

			//The number of the line to which this accentuation is going to be applicable
			storenum(5, 1, loop, input);

			//cout << "This value is stored as " << retrieve(5,0,loop) << endl; //DEBUG
			
			cout << "Enter element number(s) which will be affected by this level of accentuation or press '0' (zero) when done: ";
			test = -1;
			anyelement = false;	

			while (test != 0 || test != 0)
				{
				test = -1;
				while (test < 0 || test > (*ptrnelem))
					{
					test = numfloatinput();
					if (test < 0 || test > (*ptrnelem))
						{
						cout << "Invalid value! Please enter again: ";
						}
					}
				if (test != 0)
					{
					input = test;

				/*IMPORTANT!!! Levels of accentuation are shifted TWO elements to the right since the first element of every array is
				the descriptor of the percentage of accentuation*/

					storenum(5, input+1, loop, 1);
					cout << "Accent applied to element " << input << ".\n";
					}
				else	{
					anyelement = false;
					cout << "Completed with this level.\n";
					cout << "Accentuated elements in this line are: ";
					for (loop2 = 2; loop2 < (*ptrnelem+2); loop2++)
						{
						if ((retrieve(5, loop2, loop)) == 1)
							{
							cout << (loop2 - 1) << " ";
							anyelement = true;
							}
						}
					if (!anyelement)
						{
						cout << "none";
						}
					}
				}
				cout << endl
			    	 << endl;
			}
		cout << "Process is complete.\n";
		if (array_initialized)
			{
			cout << "Since your array has been initialized already, due to accentuation changes, it will have to be reinitialized. You will find this option in the main menu...\n";
			}
		}

	*ptraccent = nlevels;
	}




/*------------------------- end of accent entering function ---------------------------*/






/*----------------------------------- wiping out of array(s) --------------------------*/

void wipeoutarray()
	{
//	extern int *ptr_array_nelem, *ptrnlines;
	int counterx, countery;

	for (countery = 0; countery < *ptrnlines; countery++)
		{
		for (counterx = 0; counterx < *ptr_array_nelem; counterx++)
			{
			storenum(2, counterx, countery, 0);
			}
		}
	cout << "Done.\n";
	}

void wipeoutcurve()
	{
	extern int *ptrncurves;
	int counterx, countery;

	for (countery = 0; countery < *ptrncurves; countery++)
		{
		for (counterx = 0; counterx < 4; counterx++)
			{
			storenum(4, counterx, countery, 0);
			}
		}
	cout << "Done.\n";
	}


/*----------------------------------- end of wipeout functions -----------------------------------*/










/*----------------------------------------- curves functions --------------------------------------*/

void infocurve()
	{
	//extern int *ptrnelem, *ptrnlines, *ptrnunits, *ptrlastrep;
	//extern float *ptr_total_elem, *ptr_total_rep;

	cout 	<< "In order to initialize this curve, you need to enter the applicability of the curve, starting point, ending point, starting level of probability and ending level of probability (except in the case of linear horizontal function).\n";

	if (*ptrncurves == 0)
		{	
		cout	<< "\nIMPORTANT! The FIRST curve you will define will need to be defined for the WHOLE piece! Even more so, every element that will not be covered with subsequent curves will assume the probability based on this curve. This will be the 'backbone' of your piece's phrasing structure.\n";
		}

	cout	<< "\nThe total number of repetition(s) in the current structure is " << *ptr_total_rep << "\n";

	if (*ptrlastrep > 0)
		{
		cout << "The last repetition is incomplete and holds " << *ptrlastrep << " unit(s).\n";
		}

	cout << "The number of unit(s) in a single repetition is " << *ptrnunits;
	cout << "\nThe number of element(s) in a single repetition is " << *ptrnelem;
	cout << "\nThe TOTAL number of element(s) in the whole structure is " << *ptr_total_elem;
	cout << "\nYou have " << *ptrnlines << " line(s) initialized.";
	cout << "\nYou have " << *ptrncurves << " curve(s) initialized.\n\n";
	}



//Function that initializes the curve data, it is called by either editing curve function or the init curve function
void curvedata(int curve, int curvenum)
	{
	system("clear"); //CLEAR THE SCREEN

//	extern int *ptrnelem, *ptrnlines, *ptrnunits, *ptrlastrep;
//	extern float *ptr_total_elem, *ptr_total_rep;

	int input, maininput;
	float percentage;
	int counter;

	char dummychar;

	int lineapply = -1;
	int start = -1;
	int end = -1;
	float startpercent = -1;
	float endpercent = -1;

	int repetition = 0;
	int unit = 0;
	int tempelement = 0;
	int element = 0;
	int compareelem = 0;
	int percentelement = 0; //this is if the user decides to enter the position of the curve by using nrep, nunit and nelement

	int repetition2 = 0;
	int unit2 = 0;
	int tempelement2 = 0;
	int element2 = 0;
	int percentelement2 = 0;

	infocurve();

	storenum(4, 0, curvenum, curve); //store the type of the curve as the 1ST ELEMENT

	if (curvenum == 0) //if this is the first curve to be initialized, then assume it is for a whole piece
		{
		cout << "This is your first (DEFAULT) curve to be defined. Thus your starting and ending elements are automatically set to the outer edges of the piece and the curve is applicable to ALL lines.\n\n";
		start = 1;
		end = *ptr_total_elem;
		lineapply = 0;

		storenum(4, 2, curvenum, start); //storing given values
		storenum(4, 4, curvenum, end);
		storenum(4, 1, curvenum, lineapply);
		}

	//Entering the line(s) to which this curve will be applicable
	if (lineapply == -1)
		{
		cout << "Enter which line will be affected by this curve, or enter 0 if you want it to be applicable to ALL lines: ";
		input = -1;
		while (input < 0 || input > *ptrnlines)
			{
			input = numfloatinput();
			if (input < 0 || input > *ptrnlines)
				{
				cout << "Please enter a valid number: ";
				}
			}
		lineapply = input;
		storenum(4, 1, curvenum, lineapply); //storing the applicable line value where 0 means "all lines"
		}		



	//Entering the starting point
	if (start == -1)
		{
		cout << endl
		     << "Enter the starting point. Plase press:\n"
		     << "[1] if you know exact element number (including repetitions)\n"
		     << "[2] if you want to enter the repetition number, unit number and the element number\n"
		     << "[3] if you want to use percentages in order to designate the position in the piece\n"
		     << endl;

		input = -1;
		maininput = -1;
		
		while (maininput < 1 || maininput > 3)
			{
			maininput = numfloatinput();
			if (maininput == 1)
				{
				cout << "Enter starting element number: ";
				input = 0;
				while (input < 1 || input > *ptr_total_elem)
					{
					input = numfloatinput();
					if (input < 1 || input > *ptr_total_elem)
						{
						cout << "Please enter a valid number: ";
						}
					}
				element = input;
				}
			if (maininput == 2)
				{
				cout << "Enter the number of repetition in which you want the curve to start: ";
				input = 0;
				while (input < 1 || input > *ptr_total_rep)
					{
					input = numfloatinput();
					if (input < 1 || input > *ptr_total_rep)
						{
						cout << "Please enter a valid number: ";
						}
					}			
				repetition = input;
				cout << "Enter the number of unit within the selected repetition where you want the curve to start (please note that you can NOT select the last unit of the piece): ";
				input = 0;
				while (input < 1 || input > *ptrnunits || *ptrlastrep > 0 && repetition == *ptr_total_rep && input > *ptrlastrep || repetition == *ptr_total_rep && input == *ptrnunits && lineapply == 0 || repetition == *ptr_total_rep && input > *ptrnunits)
				//if value of the unit is less than 1 or greater of the number of units, OR if it is the last INCOMPLETE repetition and the no of units surpases no of present units in that repetition
					{
					input = numfloatinput();
					if (input < 1 || input > *ptrnunits || *ptrlastrep > 0 && repetition == *ptr_total_rep && input > *ptrlastrep || repetition == *ptr_total_rep && input > *ptrnunits)
						{
						cout << "Please enter a valid number: ";
						}
					if (repetition == *ptr_total_rep && input >= *ptrnunits && lineapply == 0)
						{
						cout << "The start of the curve can not begin in the last unit of the piece due to fact that it is applicable to all lines. Please enter a valid number: ";
						}
					}			
				unit = input;

				if (retrieve(3, unit-1, lineapply-1) == 0  && lineapply != 0 || lineapply == 0)
				//if the value of elements in the given unit is equal to 0 OR curve is applicable to all lines
					{
					tempelement = 0;

					for (counter = 0; counter < unit; counter++) //retrieving the number of elements up to the given unit
						{
						//cout << "counter = " << counter << " tempelement = " << tempelement << "retrieve = " << endl; //DEBUG
						if (counter == unit - 1)
							{
							tempelement = tempelement + 1;
							}
							else if (lineapply == 0)
							{
							tempelement = tempelement + retrieve(3, counter, lineapply);
							}
						else if (lineapply > 0)
							{
							tempelement = tempelement + retrieve(3, counter, lineapply - 1);
							}
						}

					element = ((repetition-1) * (*ptrnelem)) + tempelement;
					//cout << "element = " << element << " repetition = " << repetition << " ptrnelem = " << *ptrnelem << " unit = " << unit << " tempelement = " << tempelement << endl; //DEBUG
					if (element == 0) { element = 1; } //element number can not be lesser than 1
					if (lineapply > 0)
						{
 						cout << "The unit in the given line is empty, thus the curve will be applied to the closest element, in this case element no. " << element << ".";
						}
					if (lineapply == 0)
						{
						cout << "This curve is applied to all lines, thus the end of it is adjusted to the nearest element to the beginning of this unit which is in this case element no. " << element << ".";
						}
					}
				if (lineapply > 0 && retrieve(3, unit-1, lineapply-1) != 0) //if curve is applicable to an individual line and the value of the current unit is NON-ZERO
					{
					cout << "Current unit has " << retrieve(3, unit-1, lineapply-1) << " element(s). ";
					tempelement = 0;
					for (counter = 0; counter < unit; counter++) //retrieving the number of elements up to the given unit
						{
						if (counter != (unit - 1))
							{
							tempelement = tempelement + retrieve(3, counter, lineapply-1);
							}
						}
					cout << "Enter the element value within the current unit: ";
					input = 0;
					while ( input < 1 || input > retrieve(3, unit-1, lineapply-1) )
						{
						input = numfloatinput();
						if ( input < 1 || input > retrieve(3, unit-1, lineapply-1) )
							{
							cout << "Please enter a valid number: ";
							}
						}
					compareelem = input;
					element = input + tempelement + ((repetition-1) * (*ptrnelem));
					cout << "Given element's number is " << element << ".\n";
					if (element == 0) { element = 1; } //element number can not be lesser than 1
					//value is equal to the given element + no of elements from all the preceeding units in the given repetition + nrep								
					}
				}
			if (maininput == 3)
				{
				input = -1;
				cout << "Enter the percentage of the piece where you want the curve to start (0 - 100%): ";
				while (input <= 0 || input >= 100)
					{
					input = numfloatinput();
					if(input <= 0 || input >= 100)
						{
						cout << "Please enter a valid number: ";
						}
					}
				element = ( ((*ptr_total_elem) * input) / 100 ); //calculating the percentage of elements where the curve starts
				percentelement = input;
				}
			start = element;
			storenum(4, 2, curvenum, start); //storing the starting point of the curve
			}
		}
	//Entering the ending point
	if (end == -1)
		{
		if (maininput == 1)
			{
			cout << "Enter ending element number: ";
			input = 0;
			while (input <= start || input > *ptr_total_elem)
				{
				input = numfloatinput();
				if (input <= start || input > *ptr_total_elem)
					{
					cout << "Please enter a valid number: ";
					}
				}
			element2 = input;
			}
		if (maininput == 2)
			{
			cout << "Enter the number of repetition in which you want the curve to end: ";
			input = 0;
			while (input < repetition || input > *ptr_total_rep || input == repetition && unit == *ptrnunits && element == *ptrnelem || lineapply == 0 && unit == *ptrnunits && input == repetition)
			//if it is smaller number than the last repetition, that is also invalid
				{
				input = numfloatinput();
				if (input < repetition || input > *ptr_total_rep)
					{
					cout << "Please enter a valid number: ";
					}
				if (input == repetition && unit == *ptrnunits && element == *ptrnelem)
					{
					cout << "The last element within this repetition has been designated as the starting point, thus this repetition can NOT be selected as a ending point! Please enter a valid number: ";
					}
				if (lineapply == 0 && unit == *ptrnunits && input == repetition)
					{
					cout << "This curve is applicable to all lines, thus the ending point can NOT be in the same unit as the starting one, and since starting one begins in the last unit of this repetition, this repetition is not selectable. Please enter a valid nunmber: ";
					}
				}			
			repetition2 = input;
			cout << "Enter the number of unit within the selected repetition where you want the curve to end: ";
			input = 0;
			while (input <= unit && repetition2 == repetition && lineapply == 0 || input < unit && repetition2 == repetition || input < 1 || input > *ptrnunits || *ptrlastrep > 0 && repetition2 == *ptr_total_rep && input > *ptrlastrep || repetition2 == repetition && input < unit)
			//if it is also within the same repetition and the unit is lesser, that is also invalid
			//if value of the unit is less than 1 or greater of the number of units, OR if it is the last INCOMPLETE repetition and the no of units surpases no of present units in that repetition
				{
				input = numfloatinput();
					if (input <= unit && repetition2 == repetition || input < 1 || input > *ptrnunits || *ptrlastrep > 0 && repetition2 == *ptr_total_rep && input > *ptrlastrep || repetition2 == repetition && input < unit)
					//if it is also within the same repetition and the unit is lesser, that is also invalid
					{
					cout << "Please enter a valid number: ";
					}
					if (input == unit && repetition2 == repetition && lineapply == 0)
						{
						cout << "Since the curve is applicable to all lines, it has to start at the beginning of a specific unit, thus you can NOT select the same unit. Please enter a valid number: ";
						}
				}			
				unit2 = input;
			if (retrieve(3, unit-1, lineapply-1) == 0 && lineapply != 0 || lineapply == 0)
			//if the value of elements in the given unit is equal to 0 OR curve is applicable to all lines
				{
				tempelement2 = 0;
				for (counter = 0; counter < unit2; counter++) //retrieving the number of elements up to the given unit
					{
					if (counter == unit2 - 1)
						{
						tempelement2 = tempelement2 + 1;
						}
					if (lineapply == 0)
						{
					tempelement2 = tempelement2 + retrieve(3, counter, lineapply);
						}
						else if (lineapply > 0)
						{
						tempelement2 = tempelement2 + retrieve(3, counter, lineapply - 1);
						}
					}
				element2 = ((repetition2-1) * (*ptrnelem)) + tempelement2;
				if (lineapply > 0)
					{
						cout << "The unit in the given line is empty, thus the curve will be applied to the closest element, in this case element no. " << element << endl;
					}
				if (lineapply == 0)
					{
					cout << "This curve is applied to all lines, thus the end of it is adjusted to the nearest element to the beginning of this unit which is in this case element no. " << element << endl;
					}
				}
			if (lineapply > 0 && retrieve(3, unit2 - 1, lineapply - 1) != 0) //if curve is applicable to an individual line and the value of the current unit is NON-ZERO
				{
					cout << "Current unit has " << retrieve(3, unit2 - 1, lineapply - 1) << " element(s). ";				tempelement2 = 0;
				for (counter = 0; counter < unit2; counter++) //retrieving the number of elements up to the given unit
					{
					if (counter != (unit2 - 1))
						{
						tempelement2 = tempelement2 + retrieve(3, counter, lineapply-1);
						}
					}
				cout << "Enter the element value within the current unit: ";
				input = 0;
				while ( input < 1 || input > retrieve(3, unit2-1, lineapply-1) || unit2 == unit && repetition2 == repetition && input <= compareelem )
				//if the number is in the same unit and is smaller or equal to the starting point, that is also an error
					{
					input = numfloatinput();
					if ( input < 1 || input > retrieve(3, unit2-1, lineapply-1) || unit2 == unit && repetition2 == repetition && input <= compareelem  )
						{
						cout << "Please enter a valid number: ";
						}
					}
				element2 = input + tempelement2 + ((repetition2 - 1) * (*ptrnelem));
				cout << "Given element's number is " << element2 << ".\n";
				//value is equal to the given element + no of elements from all the preceeding units in the given repetition + nrep								
				}
			}
		if (maininput == 3)
			{
			input = -1;
			cout << "Enter the percentage of the piece where you want the curve to end (0 - 100%): ";
			while (input <= percentelement || input > 100)
				{
				input = numfloatinput();
				if(input <= percentelement || input > 100)
					{
					cout << "Please enter a valid number: ";
					}
				}
			element2 = ( ((*ptr_total_elem) * input) / 100 ); //calculating the percentage of elements where the curve ends
			percentelement2 = element2;
			}
		end = element2;
		storenum(4, 4, curvenum, end); //storing the starting point of the curve
		}

		

	//Entering the starting value
	if (startpercent == -1)
		{
		cout << "Enter the starting probability of the curve in % (this can be between 0% and 100%): ";
		while (startpercent < 0 || curve > 2 && curve < 5 && startpercent >= 100 || startpercent > 100 || curve > 4 && startpercent <= 0)
			{
			startpercent = numfloatinput();
			if  (startpercent < 0 || curve > 2 && curve < 5 && startpercent >= 100 || startpercent > 100 || curve > 4 && startpercent <= 0)
				{
				cout << "Please enter a valid number: ";
				}
			}
		storenum(4, 3, curvenum, startpercent);
		cout << "Your starting probability value is " << retrieve(4, 3, curvenum) << "%.\n";
		}




	//Entering the ending value
	if (endpercent == -1 && curve != 2)
	//if curve id is 2, that means that the curve is just a horizontal line, thus it does not need the ending value, it's identical to the starting one
		{
		cout << "Enter the ending probability of the curve in % (this can be between 0% and 100%): ";
		while (endpercent <= startpercent && curve < 5 && curve > 1 || endpercent >= startpercent && curve > 4 || endpercent > 100 || endpercent < 0 || endpercent == startpercent && curve == 1)
			{
			endpercent = numfloatinput();
			if  (endpercent <= startpercent && curve < 5 && curve > 1 || endpercent >= startpercent && curve > 4 || endpercent > 100 || endpercent < 0 || endpercent == startpercent && curve == 1)
				{
				if (endpercent < startpercent && curve < 5 && curve > 2)
					{
					cout << "In this type of function you need to have a HIGHER ending value than the beginning one. ";
					}
				if (endpercent >= startpercent && curve > 4)
					{
					cout << "In this type of function you need to have a LOWER ending value than the beginning one. ";
					}
				if (endpercent == startpercent && curve == 1)
					{
					cout << "You have selected a curve which needs to have ending probability either HIGHER or LOWER from the starting probability. ";
					}
				cout << "This is an invalid value! Please enter a valid number: ";
				}
			}
		storenum(4, 5, curvenum, endpercent);
		cout << "Your ending probability value is " << retrieve(4, 5, curvenum) << "%.\n";
		}	
	if (curve == 2) //if this is a horizontal linear curve
		{
		endpercent = retrieve(4, 3, curvenum);
		storenum(4, 5, curvenum, endpercent);
		cout << "Your ending probability is equal to the starting one due to the nature of this curve.\n";
		}

	cout << "You have completed the initialization of this curve...\n";

	//Performing a test DEBUG
	cout << "Testing: ";
	for (counter = 0; counter < 6; counter++)
		{
		cout << retrieve(4, counter, curvenum) << " ";
		}
	cout << endl << "End of the test.\n"
	     << "Press [C] to continue...";

	cin >> dummychar;
	}






//Main interface for curve input
int curvesinput()
	{
	system("clear"); //CLEAR THE SCREEN

	cout << "When initializing curves you will have a choice of 6 functions. For more informantion on these read the help document. You can store up to 500 curves. The resulting curve will be the average of all overlapping curves (excluding the DEFAULT one)."
	     << endl
	     << endl;

	//extern int *ptrncurves;
	char input;
	
	int curvenum = ncurves; //equalizing number of curves with the current number (it's being reset in the main function as of V 0.76.2)
	boolean loop = true;

	while (loop)
		{
		cout << "Please choose one of the following:\n"
		     << endl
		     << "[1] LINEAR function with gradual ASCENT or DESCENT\n"
		     << "[2] LINEAR HORIZONTAL function\n"
		     << "[3] EXPONENTIAL function with the ASCENDING curve at the END\n"
		     << "[4] EXPONENTIAL function with the ASCENDING curve at the BEGINNING\n"
		     << "[5] EXPONENTIAL function with the DESCENDING curve at the END\n"
		     << "[6] EXPONENTIAL function with the DESCENDING curve at the BEGINNING\n"
		     << endl
		     << "[X] to exit\n"
		     << endl;

		input = '0';
		cin >> input;

		if (input == '1')
			{
			curvedata(1, curvenum);
			curvenum++;
			}
		if (input == '2')
			{
			curvedata(2, curvenum);
			curvenum++;
			}
		if (input == '3')
			{
			curvedata(3, curvenum);
			curvenum++;
			}
		if (input == '4')
			{
			curvedata(4, curvenum);
			curvenum++;
			}
		if (input == '5')
			{
			curvedata(5, curvenum);
			curvenum++;
			}
		if (input == '6')
			{
			curvedata(6, curvenum);
			curvenum++;
			}
		if (input == '7')
			{
			curvedata(7, curvenum);
			curvenum++;
			}
		if (input == 'x' || input == 'X')
			{
			cout << "Initialization of curves completed.";
			cout << "You have initialized " << curvenum << " curves. You will be able to review these from the main menu...\n";
			*ptrncurves = curvenum; //external variable is saving the number of curves in the current initialization
			return 0;
			}
		system("clear"); //CLEAR THE SCREEN
		}
	return 0;
	}
	






//WRITING OUT THE PRINT-TEST FUNCTION
void reviewcurves()
	{
//	extern int *ptrncurves;

	int counterx, countery;
	int tempval;
	char *tempname;

	boolean disabledcurve = false;

	cout << "Here's an overview of your initalized curves:\n\n";

	for (countery = 0; countery < *ptrncurves; countery++)
		{
		disabledcurve = false;
		for (counterx = 0; counterx < 6; counterx++)
			{
			tempval = retrieve(4, counterx, countery);
			if (counterx == 0)
				{
				cout << "Curve no. " << countery+1 << " ";
				if (tempval == 1) { tempname = "LINEAR function with gradual ASCENT or DESCENT"; }
				if (tempval == 2) { tempname = "LINEAR HORIZONTAL function"; }
				if (tempval == 3) { tempname = "EXPONENTIAL function with the ASCENDING curve at the END"; }
				if (tempval == 4) { tempname = "EXPONENTIAL function with the ASCENDING curve at the BEGINNING"; }
				if (tempval == 5) { tempname = "EXPONENTIAL function with the DESCENDING curve at the END"; }
				if (tempval == 6) { tempname = "EXPONENTIAL function with the DESCENDING curve at the BEGINNING"; }
				if (tempval >0)
					{
					cout << " is a " << tempname << " ";
					}
				if (tempval == 0)
					{
					disabledcurve = true;
					cout << "is DISABLED.\n";
					}
				}
			if (counterx == 1 && !disabledcurve)
				{
				cout << "and is applicable to ";
				if (tempval == 0) { cout << "ALL lines "; }
				if (tempval > 0) { cout << "line no. " << tempval << " "; }
				}
			if (counterx == 2 && !disabledcurve)
				{
				cout << "with the starting point at element no. " << tempval << ", ";
				}
			if (counterx == 3 && !disabledcurve)
				{
				cout << "starting value of " << tempval << "%, ";
				}
			if (counterx == 4 && !disabledcurve)
				{
				cout << "ending point at element no. " << tempval << ", ";
				}
			if (counterx == 5 && !disabledcurve)
				{
				cout << "and ending value of " << tempval << "%.\n" << endl;
				}
			}
		}
	}






//WRITING OUT THE EDIT FUNCTION -- it will need to present the user with the test printout and then wipeout that line and CALL THE CURVEDATA() function
int curvesedit()
	{
	system("clear"); //CLEAR THE SCREEN

//	extern int *ptrncurves;
	int selectcurve, newcurve, curvetype = -1; //number of the curve to be edited and also the type of the curve

	char dummyprompt;

	while (selectcurve != 0)
		{
		infocurve();
		reviewcurves();

		cout << endl << "Please select the curve to be EDITED, press the next curve's number in order to ADD a new curve, or press 0 (zero) to EXIT to main menu. Please note that ALL data in that curve will be LOST!: ";

		selectcurve = -1;		

		while (selectcurve < 0 || selectcurve > *ptrncurves + 1)
			{
			selectcurve = numfloatinput();
			if (selectcurve < 0 || selectcurve > *ptrncurves + 1)
				{
				cout << "Invalid value! Please try again: ";
				}
			}
		if (selectcurve == 0)
			{
			cout << "Finished editing curves...\n";
			return 0;
			}
		if (selectcurve > 0)
			{
			system("clear");
			if (selectcurve == *ptrncurves + 1)
				{
				cout << "You chose to add a NEW curve.";
				*ptrncurves = *ptrncurves + 1;
				newcurve = true;
				}
			else	{ newcurve = false;}
			cout << "\nEnter the type of the curve:\n\n"
			     << "[1] LINEAR function with gradual ASCENT or DESCENT\n"
			     << "[2] LINEAR HORIZONTAL function\n"
			     << "[3] EXPONENTIAL function with the ASCENDING curve at the END\n"
			     << "[4] EXPONENTIAL function with the ASCENDING curve at the BEGINNING\n"
			     << "[5] EXPONENTIAL function with the DESCENDING curve at the END\n"
			     << "[6] EXPONENTIAL function with the DESCENDING curve at the BEGINNING\n";
			if (!newcurve)
				{
				cout << "[0] to DISABLE this curve\n";
				}
			cout << endl;

			curvetype = -1;
			while (curvetype < 0 || curvetype > 6)
				{
				curvetype = numfloatinput();
				if (curvetype < 0 || curvetype > 6)
					{
					cout << "Invalid value! Please try again: ";
					}
				}
			if (curvetype == 0)
				{
				if (selectcurve == 1)
					{
					cout << "This is your 'main' curve and thus it can NOT be disabled, it can only be EDITED. Nothing has been done.\n";
					}
				if (selectcurve > 1)
					{
					storenum(4, 0, selectcurve-1, 0);
					cout << "Curve number " << selectcurve << " has been DISABLED.\n";
					}
				cout << "Press [C] to continue...\n";

				cin >> dummyprompt;
				}
			else if (curvetype > 0)
				{
				curvedata(curvetype, selectcurve-1);
				}
			}
		system("clear");
		}
	return 0;
	}	


//PART OF THE CALCULATION PROCESS
//IMPORTANT: This function is dumb by nature, and does not check if the retrieval of the value is even applicable!
//So ALL CHECKS must be made prior to calling this function!!!
//Curvenum reflects the number of the curve, starting with number 0, NOT THE TYPE OF THE CURVE!
//IMPORTANT: all the percentages are stored in hundreds, so they have to be divided by 100!!!
float curvecalculate( int curvenum, int element )
	{
	float tempcurveval;
	
	//this function is not concerned with the curveapply variable, since it assumes that check has occured prior to calling of this function
	int curvetype, curvestart, curveend;
	int duration; //duration of the curve
	float difference; //difference between startval and endval
	float change = 0; //change of the value per element (for linear functions) or change of the x-axis in the exponential functions
	float startval, endval;
	float tempexpo; //temp value for exponential functions

	curvetype = retrieve(4, 0, curvenum);
	curvestart = retrieve(4, 2, curvenum);
	curveend = retrieve(4, 4, curvenum);
	startval = (float)retrieve(4, 3, curvenum) / 100;
	endval = (float)retrieve(4, 5, curvenum) / 100;
	duration = curveend - curvestart;
	difference = (float)(endval - startval);
	
	if (difference < 0) { difference = -difference; } //difference is always positive

	if (curvetype == 1) { change = difference / duration;  } //change per element
	if (curvetype > 2)
		{
		cout << "Defining a change for exponential function...\n"; //DEBUG
		change = (float)(1.0 / duration);   //change of x-axis per element
		tempexpo = (float)( ( element - curvestart ) * change );  //position of the element on the 0-1 axis
		cout << "Tempexpo = " << tempexpo << " Duration = " << duration << " Change = " << change << endl; //DEBUG
		}

	switch(curvetype)
		{
		case 1:
			if (endval > startval) //ascending linear
				{
				tempcurveval = ( startval + ( ( element - curvestart ) * change ) );
				}
			if (endval < startval) //descending linear
				{
				tempcurveval = ( startval - ( ( element - curvestart ) * change ) );
				}
			break;
		case 2:
			tempcurveval = startval; //linear horizontal
			break;
		case 3:
			tempcurveval = startval + (( tempexpo * tempexpo ) * difference); //expo with the ascent at the end
			break;
		case 4:
			tempcurveval = startval + ( ( 1.0 - (( 1.0 - tempexpo ) * ( 1.0 - tempexpo )) ) * difference ); //expo with the ascent at the beginning
			break;
		case 5:
			tempcurveval = startval - (( tempexpo * tempexpo ) * difference ); //expo with the descent at the end
			break;
		case 6:
			tempcurveval = startval - ( ( 1.0 -  (( 1.0 - tempexpo ) * ( 1.0 - tempexpo )) ) * difference ); //expo with the descent at the beginning
			break;
		}

	cout << "Result for the " << curvetype << ". curve type is " << tempcurveval << endl; //DEBUG
	cout << "Startval = " << startval << " Endval = " << endval << endl; //DEBUG
	cout << "Curveend = " << curveend << " Curvestart = " << curvestart << " Difference = " << difference << " Change = " << change << endl; //DEBUG
	return tempcurveval;
	}

/*-------------------------------------- end of curves functions -----------------------------------*/






/*------------------------------------------- file management functions -----------------------------*/

int outputfile()
	{

	system("clear"); //CLEAR THE SCREEN

//	extern string name;
//	extern char event1, event2, event3, noevent1, noevent2;

	string inputname;

	int input = -1;
	char dummykey;

	cout << "Please note that it is very important that you select the directory in which you DO HAVE PERMISSIONS to write to. Otherwise you will not be able to save your work!\n" << endl;

	while (input < 0 || input > 3 || input != 0)
		{

	cout << "Please choose one of the following:\n" << endl
	     << "[1] for selecting the output file name (currently set as: " << name << ")\n"
	     << "[2] for saving your work into a separate file (NOT IMPLEMENTED YET)\n"
	     << "[3] to load back the saved work (NOT IMPLEMENTED YET)\n"
	     << "[4] to specify the characters designated to reflect 'event' and 'no event' in the final score\n"
	     << endl
             << "[0] to exit this menu\n"
	     << endl
	     << ">";

		input = numfloatinput();

		switch(input)
			{
			case 0:
				cout << "\nCompleted initializing file(s). Your current file name is " << name << ".\n";
				return 0;
				break;
			case 1:
				cout << "\nPlease enter the name of the score-file including the OPTIONAL path. If you omit the path, the file will be created in the current directory:\n" << ">";
				cin >> inputname;
				name = inputname;
				cout << "Done.\n";	
				break;
			case 2:
				cout << "\nSORRY, NOT IMPLEMENTED YET...\n";
				break;
			case 3:
				cout << "\nSORRY, NOT IMPLEMENTED YET...\n";
				break;
			case 4:
				cout << "\nWould you like to have events described in terms of their accentuation? (Y/N) ";
				cin >> dummykey;
				if (dummykey == 'y' || dummykey == 'Y')
					{
					displayevent = 2;
					break;
					}
				displayevent = 1;
				cout << "Please type the new 'UNDER-ACCENTED EVENT' character: ";
				cin >> dummykey;
				event1 = dummykey;
				cout << "Please type the new 'NON-ACCENTED EVENT' character: ";
				cin >> dummykey;
				event2 = dummykey;
				cout << "Please type the new 'ACCENTED EVENT' character: ";
				cin >> dummykey;
				event3 = dummykey;
				cout << "Please type the new 'NON-ZERO-ACCENTED NO-EVENT' character: ";
				cin >> dummykey;
				noevent1 = dummykey;
				cout << "Now, please type the new 'ZERO-ACCENTED NO-EVENT' character: ";
				cin >> dummykey;
				noevent2 = dummykey;
				cout << "Your newly initialized characters are:\n"
				     << event1 << " for an 'UNDER-ACCENTED EVENT'\n"
				     << event2 << " for an 'NON-ACCENTED EVENT'\n"
				     << event3 << " for an 'ACCENTED EVENT'\n"
				     << noevent1 << " for an 'NON-ZERO-ACCENTED NO-EVENT'\n"
				     << noevent2 << " for an 'ZERO-ACCENTED NO-EVENT'\n";
				break;
			}
		cout << "Press [C] to continue...";
		cin >> dummykey;
		system("clear");
		}
	return 0;
	}


/*------------------------------------------- end of file management functions ----------------------*/










/*---------------------------- number of lines to be heard function ---------------------------------*/

//display current hearline
void showcurrenthearline()
	{

//	extern float *ptr_total_elem;

	int counter, value, newvalue;
	int num_of_ranges = value = 0;

	//cout << "Ptrtotalelem" << *ptr_total_elem << "nrange = " << num_of_ranges << endl; //DEBUG
	cout << "Current layout of this array is:\n"
	     << endl;

	for (counter = 1; counter <= *ptr_total_elem; counter++)
		{
		newvalue = retrieve(6, counter, 0);
		//cout << counter << endl; //DEBUG
		if (newvalue != value)
			{
			num_of_ranges++;
			if (value != 0) //if this thing is not the starting range append the end of the sentence
				{
				cout << counter-1 << ". \n" << endl;
				}
			cout << num_of_ranges << ". range of the array starts at element " << counter << " with having a maximum of " << newvalue << " line(s) audible at any given time, and ends at element ";
			value = newvalue;
			}
		if (counter == *ptr_total_elem) //if it is the last range or if the range extends over the whole piece
			{
			cout << counter << ". \n" << endl;
			}
		}
	cout << endl;
	}



//entering the values for both init and edit
int enterhearline()
	{

//	extern float *ptr_total_elem;
//	extern int *ptrnlines;	

	int xe = -1;
	int value = 0;
	int input = 0;
	int maininput = 0;
	int counter = 0;
	int element2 = 0; //label for the ending element due to fact that this function has been partially copied from the curve function

	if (retrieve(6, *ptr_total_elem, 0) == 0 && retrieve(6,1,0) == 0) //if this array has not been initialized before
		{
		cout << "Since this is your first initialization, the starting element will be the FIRST element.\n";
		xe = 1;
		}

	cout << "The total number of elements is " << *ptr_total_elem << ".\n";

	if (retrieve(6, *ptr_total_elem, 0) == 0 && retrieve(6, 1, 0) != 0) //continuing initialization
		{
		cout << "Entering the next range within the piece starting with element no. ";
		for (counter = 1; counter <= *ptr_total_elem; counter++)
			{
			if (retrieve(6, counter, 0) == 0 && retrieve(6, counter-1, 0) != 0) //find the right spot to continue the first initialization
				{
				xe = counter;
				cout << xe << " :\n";
				}
			}
		}
	if (retrieve(6, *ptr_total_elem, 0) != 0) //if editing is in order
		{

		cout << "Enter the range that you wish to be edited by entering its starting element or press 0 to exit: ";
		while(xe < 0)
			{
			xe = numfloatinput();
			if (xe < 0)
				{
				cout << "Invalid value! Please try again: ";
				}
			if (xe == 0)
				{
				cout << "Editing complete.\n";
				return 0;
				}
			}
		}


	//Entering the ending point
	if (element2 == 0)
		{
		cout << endl
		     << "You will now enter the ENDING point of the range.\n"
		     << "[1] if you know exact element number (including repetitions)\n"
		     << "[2] if you want to use percentages in order to designate the position in the piece\n"
		     << endl;

		input = maininput = -1;

		while (maininput < 1 || maininput > 2)
			{
			maininput = numfloatinput();
			if (maininput == 1)
				{
				cout << "Enter ending element number: ";
				input = 0;
				while (input <= xe || input > *ptr_total_elem)
					{
					input = numfloatinput();
					if (input <= xe || input > *ptr_total_elem)
						{
						cout << "Invalid value! Please enter a valid number: ";
						}
					}
				element2 = input;
				}
			if (maininput == 2)
				{
				input = -1;
				cout << "Enter the percentage of the piece where you want this range to end (0 - 100%): ";
				while ( ((input * (*ptr_total_elem))/100) < xe || input > 100)
					{
					input = numfloatinput();
					if( ((input * (*ptr_total_elem))/100) < xe || input > 100)
						{
						cout << "Invalid value! Please enter a valid number: ";
						}
					}
				element2 = ( ((*ptr_total_elem) * input) / 100 ); //calculating the percentage of elements where the range ends
				cout << "Resulting element is " << element2 << ".\n";
				}
			}
		}

		

	//Entering the value of lines to be heard
	cout << "Enter the MAXIMUM number of lines you want to hear at the same time within this range: ";
	input = -1;
	while (input < 0 || input > *ptrnlines)
		{
		input = numfloatinput();
		if  (input < 0 || input > *ptrnlines)
			{
			cout << "Invalid value! Please enter a valid number: ";
			}
		}
	value = input;

	for (counter = xe; counter <= element2; counter++) //storing values into the array
		{
		storenum(6, counter, 0, value);
		}

	cout << "\nProcess complete.\n";

	return 0;
	}



//main edit function
int edithearline()
	{
	char test, dummy;
	boolean loop = true;

	while (loop)
		{
		system("clear"); //clear the screen

		showcurrenthearline();

		cout << "Press [E] to edit a range within the array, or press [X] to exit to main menu: ";
		cin >> test;

		if (test == 'e' || test == 'E')
			{
			cout << endl;
			enterhearline();
			cout << "Press [C] to continue...";
			cin >> dummy;
			}
		if (test == 'x' || test == 'X')
			{
			cout << "Finished editing.\n";
			return 0;
			}
		}
	return 0;
	}




//main init function
int hearlines()
	{
	//this function initializes the single dimensional array with the length of total number of elements
	system("clear"); //clear the screen

	extern float *ptr_total_elem;	
	int counter;

	boolean loop = true;

	if (retrieve(6,1,0) != 0)
		{
		cout << "Wiping out the old array...";
		for (counter= 0; counter <= *ptr_total_elem; counter++)
			{
			storenum(6,counter,0,0);
			}
		cout << "Done.\n" << endl;
		}

	cout << "You will have to enter the starting and ending point of each section that differs from the adjacent one for the whole duration of the piece The default value is 0.\n"
	     << endl;

	
	while (loop)
		{
		enterhearline();
		if (retrieve(6, *ptr_total_elem, 0) != 0)
			{
			cout << "Your initialization is now completed...\n";
			return 0;
			}
		system("clear"); //clear the screen		
		}
	}	


/*-------------------------- end of number of lines to be heard function ----------------------------*/







/*---------------------------------- CALCULATING FUNCTION -------------------------------------------*/



int calculate()
	{
	system("clear"); //clear the screen
	
	//CHARACTERS which are used to designate 'EVENT' and 'NO EVENT'
//	extern char event1, event2, event3, noevent1, noevent2;

//	extern string name; //name of the file is stored in this variable
	//extern int *ptraccent; //number of accentuation levels DON'T NEED IT, IT HAS BEEN INITIALIZED ALREADY
//	extern int *ptr_array_nelem; //total number of "objects" in the final array
//	extern int *ptrnlines; //number of lines
//	extern int *ptrncurves; //number of curves which will affect the overall shape of the piece

	//random seed and multiplier
//	extern long *ptr_rnd_seed;
//	extern float *ptr_rnd_multiply;

	float rndmultiply = *ptr_rnd_multiply; //for easier handling using local variable
	long instance = *ptr_rnd_seed; //incrementing instance for the generation of the random numbers
	long downsizeInstance = instance;

	float rndnum; //resulting random number

	//these variables are just for the info for the user (they are not used in the computation of the final array)
//	extern int *ptrnelem; //number of elements within single repetition
//	extern int *ptrnunits; //number of units within single repetition
//	extern float *ptr_total_elem; //total number of elements
//	extern float *ptr_total_dur; //total duration in seconds
//	extern float *ptr_total_rep; //total number of repetitions
//	extern float *ptr_tempo_elem; //tempo of the element/second
	
	//again for the user info, in the case last repetition is incomplete
//	extern int *ptrlastrep;
//	extern boolean balanced_units;

	const char *filename = name.c_str();

	char test, dummy; //testing character to see if the file already has something written into it
	int testnum = 0; //just a looping number to see if the actual file has something in it

	int xloop, yloop, ycurve, allowevents, eventloop; //loop counters
	int arrayval; //value of the retrieved object from the array

	float curveval; //probability value for the current element
	float accentcurveval; //accentuated curve value
	float finalval; //final truncated version of accentcurveval (only if needed, otherwise equal to accentcurveval)
	boolean checkcurveval;

	//info about the current curve
	int curvetype, curveapply, curvestart, curveend;	
	//float curvestartval, curveendval; //NOT NEEDED!!!

	int accent, elementnum, curveelementnum; //values for the current element

	int minutes; //just for the more accurate display of time within the score file
	float compareminutes;

	//ARRAY for checking how many of the given events will actually happen in order to satisfy the number of lines allowed
	float eventcheck[100];

	//comparing for multiple events of same accentuation designated for truncating
	int tempeventcheck[100];
	int sumevents;
	int rndcheckevent;
	int loopcheckevent;

	//number of events in the current batch vs. allowed
	int tempnumevents;
	int numevents;

	float eventworth; //comparison value from the eventcheck array
	int eventid; //comparison value's position in the eventcheck array

	//additional curve info (as of VERSION 0,75.8)
	int curvestartval, curveendval;




	//Calculation interface and output file initialization
	cout 	<< "Beginning with calculation...\n"
		<< "Your final score will be stored in the file named " << filename << ".\n"
		<< "Attempting to create the file...\n";

	//testing to see if the file has already some kind of data in it
	ifstream infile( filename );

	if ( infile.get( test ) )
		{
		testnum++;
		//cout << "*"; //DEBUG
		if (testnum > 0)
			{
			cerr << "The file you have specified for output already has been written into. Are you sure you want to OVERWRITE it? Press any key to continue or press 'N' to cancel this operation: ";
			cin >> dummy;
			if (dummy == 'n' || dummy == 'N')
				{
				return 0;
				}
			}
		}

	//creating file
	ofstream outfile( filename );

	//if the creation of the file has failed
	if ( ! outfile )
		{
		cerr << "Cannot create the file. Make sure that you have permissions to write to this directory. Calculation has been cancelled.\n";
		return 0;
		}


	cout << "Done.\n" << "Writing header information into the scorefile...";


	//Entering the basic info into the output file
	outfile << "One cell has " << *ptrnlines << " line(s), " << *ptrnunits << " unit(s), and " << *ptrnelem << " element(s).\n";

	if (!balanced_units)
		{
		outfile << "This cell is poly-metric.\n";
		}

	outfile << "Total number of cells is " << *ptr_total_rep << " containing " << *ptr_total_elem << " element(s).\n";

	if (balanced_units && *ptrlastrep > 0)
		{
		outfile << "The last repetition is incomplete, containing " << *ptrlastrep << " unit(s).\n";
		}

	outfile << "Tempo setting is " << *ptr_tempo_elem << " second(s) per element.\n";
	outfile << "Conventional tempo setting is ELEMENT = " << (int)( 60/(*ptr_tempo_elem) + .5 ) << ".\n";

	cout << "The duration of a single cell is " << (float)(*ptrnelem * *ptr_tempo_elem) << " second(s).\n";
	outfile << "The duration of a single cell is " << (float)(*ptrnelem * *ptr_tempo_elem) << " second(s).\n";

	if (*ptr_total_dur > 60)	
		{
		minutes = 0;
		compareminutes = *ptr_total_dur;		
		while (compareminutes > 60)
			{
			compareminutes = compareminutes - 60;
			minutes++;
			}
		cout << "Total duration of the piece is " << minutes << " minute(s) and " << compareminutes << " second(s).\n";
		outfile << "Total duration of the piece is " << minutes << " minute(s) and " << compareminutes << " second(s).\n";
		}		
	else	{
		cout << "Total duration of the piece is " << *ptr_total_dur << " second(s).\n";
		outfile << "Total duration of the piece is " << *ptr_total_dur << " second(s).\n";
		}

	//entering legend
	outfile << endl << "LEGEND:\n"
		<< "== End of repetition\n"
		<< "-- End of unit\n"
		<< event1 << "_ Under-accented event\n"
		<< event2 << "_ Non-accented (default) event\n"
		<< event3 << "_ Over-accented event\n"
		<< noevent1 << "  Non-zero-accented no-event\n"
		<< noevent2 << "  Zero-accented no-event\n";

	outfile << "\nCURVE DEFINITIONS:\n"
		<< "<<   Point at which curve occurs\n"
		<< "\\/   Beginning of the curve\n"
		<< "/\\   End of the curve\n"
		<< "DEF  Default (zero) curve\n"
		<< "#(x) Number ID of the curve\n"
		<< "T(x) Type of the curve\n"
		<< "(x)% Starting/Ending probability\n\n";

	outfile << endl << "BEGINING OF THE SCORE:\n" << endl;

	//creating comprehensible reference to line numbers
	for (yloop = *ptrnlines; yloop > 0; yloop--)
		{
		if (yloop == 100) { outfile << yloop << " "; }
		if (yloop < 100 && yloop > 9) { outfile << " " << yloop << " "; }
		if (yloop < 10) { outfile << " 0" << yloop << " "; }
		}
	//outfile << endl;

	//creating additional respacebar (eye-candy)
	//for (yloop = *ptrnlines; yloop > 0; yloop--)
	//	{
	//	outfile << " == ";
	//	}
	//outfile << endl;


	cout << "Done.\n" << "Computing the scorefile...\n\n";

	int repetition = 1; //counter for the repetition
	boolean lastannounce = false; //to correct the last announcement

	//SCOREFILE CREATION
	for ( xloop = 0; xloop <= *ptr_array_nelem; xloop++) //main loop for all 'objects'
		{
		cout << "\nAccessing object " << xloop+1 << ":" << endl;

		outfile << endl; //finish off the line in the file

		//reinitialize event comparison variables
		tempnumevents = 0;
		numevents = 0;
		accent = 0;
		elementnum = 0;
		arrayval = 0;

		for ( yloop = *ptrnlines - 1; yloop >= 0; yloop--) //main loop for all lines starting with the last one first due to conventional score reading
			{
			arrayval = retrieve(2, xloop, yloop);

			if (arrayval == 1 && xloop != 0)
				{
				outfile << "--- ";
				}
			if (xloop == 0)
				{
				outfile << "====";
				}
			if (arrayval == 2)
				{
				outfile << "====";
				if (yloop == 0)
					{
					repetition++;
					}
				}
			if (arrayval == 3)
				{
				outfile << " .  ";
				}
			if (arrayval > 3) //if this is an element
				{

				//get the element number				
				elementnum = (int)(arrayval/1000);

				curveelementnum = elementnum; //assigning true position of the element for the curve calculation

				while (elementnum > *ptrnelem)
					{
					elementnum = elementnum - *ptrnelem;
					}

				cout << "Elementnum = " << elementnum << " Curveelementnum = " << curveelementnum << endl; //DEBUG

				//getting the number of allowed events
				numevents = retrieve(6, curveelementnum, 0);
				cout << "Numevents = " << numevents << endl; //DEBUG

				//get the accentuation
				accent = ( arrayval - ( ( (int)(arrayval/1000) )* 1000 ) );
				
				cout << "Accent = " << accent << endl; //DEBUG

				//get the curve value for the given element (starting with the 'backbone' curve, or the 0th curve in the array)
				for (ycurve = 0; ycurve < *ptrncurves; ycurve++)
					{
					if (ycurve == 0)
						{
						curveval = (float)curvecalculate(ycurve, curveelementnum);
						checkcurveval = true; //for checking if the curve has been initialized already or is it the first time
						//cout << "Curveval = " << curveval << endl; //DEBUG
						}
					else	{ //Do for all other curves but the DEFAULT ONE
						curvetype = retrieve(4, 0, ycurve);
						curveapply = retrieve(4, 1, ycurve);
						if (curvetype != 0) //if the curve is NOT DISABLED
							{
							if (curveapply == 0 || curveapply == yloop+1) //if the curve is applicable to ALL lines or to the current line, only then do the following:
								{
								curvestart = retrieve(4, 2, ycurve);
								curveend = retrieve(4, 4, ycurve);
								if (curveelementnum >= curvestart && curveelementnum <= curveend) //only if this element is affected by this curve, only then do the following:
									{
									if (checkcurveval)
										{
										curveval = (float)curvecalculate(ycurve, curveelementnum); //first non-default curve
										}
									else	{
										curveval = ( (curveval + (float)curvecalculate(ycurve, curveelementnum)) / 2.0 ); //average of the two curves
										}
									//cout << "Curveval = " << curveval << " line = " << yloop << "element = " << elementnum << "curveeelement = " << curveelementnum << endl; //DEBUG
									checkcurveval = false;
									}
								}
							}
						}
					//cout << "Curveval = " << curveval << endl; //DEBUG
					}
				//cout << "Done calculating this element's curve value.\n"; //DEBUG

				cout << "Curveval = " << curveval << endl; // DEBUG

				//multiplying that curve value with the accentuation level
				accentcurveval = ((float)curveval * (float)accent) / 100.0; //because accent is in the hundreds

				if (accentcurveval > 1.0)  //final probability CAN NOT be greater than 100% (between 0 and 1
					{
					finalval = (float)1.0;
					}
				else 	{
					finalval = (float)accentcurveval;
					}

				cout << "Accentuated curve value = " << finalval << " was " << accentcurveval << " prior to truncating.\n"; //DEBUG

				//getting the random number
				instance++;
				rndnum = brrand(instance) * rndmultiply;

				while (rndnum > 1.0)
					{
					rndnum = rndnum - 1.0;
					}

				cout << "Random number = " << rndnum << endl; //DEBUG

				//Checking if the event happens
				if (finalval >= rndnum) // IT DOES
					{
					tempnumevents++;
					cout << "This event is happening at this time. Tempnumevents = " << tempnumevents << " Allowevents = " << numevents << endl; //DEBUG
					//this ensures that the more accented notes will still have an advantage over non-accented ones in the case they happen simultaneously
					eventcheck[yloop] = (float)((float)accent + (float)finalval);
					}
				if (finalval < rndnum) //NOPE
					{
					
					//since event does not happen, might as well give it a probability 0
					eventcheck[yloop] = 0.0;
					cout << "This event will not happen at this time...\n"; //DEBUG
					}
				}
			cout << "Working...\n"; //progress bar
			//naming the number of the repetition
			//cout << "Repetition = " << repetition << " totalnrep = " << *ptr_total_rep << endl; //DEBUG
			if (arrayval == 2 && yloop == 0 && repetition <= *ptr_total_rep || xloop == 0 && yloop == 0 && repetition <= *ptr_total_rep || *ptrlastrep > 0 && balanced_units && repetition == (int)(*ptr_total_rep + 1) && !lastannounce)
				{
				cout << "Writing repetition...\n"; //DEBUG
				if (repetition <= *ptr_total_rep)
					{
					outfile << "\nREPETITION #" << repetition;
					}
				if (repetition == (int)((*ptr_total_rep) + 1) && *ptrlastrep != 0)
					{
					outfile << "\nINCOMPLETE LAST REPETITION (#" << repetition << ")";
					lastannounce = true;
					}
				}
			}


		//If there have been more events happening than allowed by the lines-to-be-heard function do:

		//wipeout old data from temcheckevent[100];
		for (eventloop = *ptrnlines - 1; eventloop >= 0; eventloop--)
			{
			tempeventcheck[eventloop] = 0;
			}

		if (tempnumevents > numevents && arrayval > 3)
			{
			cout << "\nDownsizing possible events...\n";
			for (allowevents = numevents; allowevents < tempnumevents; allowevents++)
				{
				eventworth = 1050.0;
				eventid = 0;
				loopcheckevent = 0;
				sumevents = 0;

				//checking lowest possible eventworth
				for (eventloop = *ptrnlines - 1; eventloop >= 0; eventloop--)
					{
					if (eventcheck[eventloop] > 0 && eventcheck[eventloop] <= eventworth) //finding the lowest valued non-zero element to scrap
						{
						eventworth = (float)eventcheck[eventloop];
						}
					}

				//mapping all events of same stored value
				cout << "Line(s) ";
				for (eventloop = *ptrnlines - 1; eventloop >= 0; eventloop--)
					{
					if (eventcheck[eventloop] == eventworth)
						{
						sumevents++;
						tempeventcheck[eventloop] = 1;
						cout << eventloop+1 << ", ";
						}
					}

				cout << " are candidate(s) for truncating (total of " << sumevents << " INITIAL candidate(s)). Need to truncate " << tempnumevents - allowevents << " more event(s)...\n";

				rndcheckevent = (int)((brrand(instance) * rndmultiply * (*ptrnlines)) + 1);
				while (tempeventcheck[rndcheckevent - 1] != 1)
					{
					rndcheckevent = (int)((brrand(downsizeInstance) * rndmultiply * (*ptrnlines)) + 1);
					downsizeInstance++;
					}

				//cout << "rndcheckevent = " << rndcheckevent; //DEBUG

				cout << "Randomly chosen event to be truncated is event in the line " << rndcheckevent << ".\n";

				eventid = rndcheckevent - 1;
				tempeventcheck[eventid] = 0; //scraping that event also in the comparison array
				eventcheck[eventid] = 0.0; //scraping the lowest non-zero element
/*				cout << "Testing: ";
				for (eventloop = *ptrnlines - 1; eventloop >= 0; eventloop--)
					{
					cout << eventcheck[eventloop] << " ";
					}
*/
				}
			}

		//WRITING OUT THE RESULTING EVENTS
		if (arrayval > 3)
			{
			for (eventloop = *ptrnlines - 1; eventloop >= 0; eventloop--)
				{
				//get the accentuation AGAIN due to independent loop
				arrayval = retrieve(2, xloop, eventloop);
				accent = ( arrayval - ( ( (int)(arrayval/1000) )* 1000 ) );
				if (eventcheck[eventloop] == 0 && accent > 0) { outfile << " " << noevent1 << "  "; }
				if (eventcheck[eventloop] == 0 && accent == 0) { outfile << " " << noevent2 << "  "; }
				if (eventcheck[eventloop] > 0 && accent > 100 && displayevent == 1) { outfile << " " << event3 << "_ "; }
				if (eventcheck[eventloop] > 0 && accent == 100 && displayevent == 1) { outfile << " " << event2 << "_ "; }
				if (eventcheck[eventloop] > 0 && accent < 100 && displayevent == 1) { outfile << " " << event1 << "_ "; }
				if (eventcheck[eventloop] > 0 && displayevent == 2 && accent >= 100) { outfile << accent << " "; }
				if (eventcheck[eventloop] > 0 && displayevent == 2 && accent < 100 && accent >= 10) { outfile << accent << "  "; }
				if (eventcheck[eventloop] > 0 && displayevent == 2 && accent < 10) { outfile << accent << "   "; }
				}
			}
		cout << "\nWriting out curve info into the score...\n";
		for (ycurve = 0; ycurve < *ptrncurves; ycurve++)
			{
			curvestart = retrieve(4, 2, ycurve);
			curveend = retrieve(4, 4, ycurve);
			curvetype = retrieve(4, 0, ycurve);
			curveapply = retrieve(4, 1, ycurve);
			curvestartval = retrieve(4, 3, ycurve);
			curveendval = retrieve(4, 5, ycurve);
			if (curveelementnum == curvestart && arrayval > 3 || curveelementnum == curveend && arrayval > 3)
				{
				if (curveelementnum == curvestart)
					{
					outfile << "  << \\/ ";
					if (ycurve == 0) { outfile << "DEF-T" << curvetype << "-"; }
					else { outfile  << "#" << ycurve+1 << "-T" << curvetype << "-"; }
					if (curveapply == 0)
						{
						outfile << "ALL";
						}
					else	{
						if (curveapply < 10)
							{
							outfile << "00" << curveapply;
							}
						if (curveapply >= 10 && curveapply < 100)
							{
							outfile << "0" << curveapply;
							}
						if (curveapply == 100)
							{
							outfile << curveapply;
							}
						}
					outfile << "-";
					if (curvestartval < 10)
						{
						outfile << "00" << curvestartval << "%  ";
						}
					if (curvestartval >= 10 && curvestartval < 100)
						{
						outfile << "0" << curvestartval << "%  ";
						}
					if (curvestartval == 100)
						{
						outfile << curvestartval << "%  ";
						}
					}
				if (curveelementnum == curveend)
					{
					outfile << "  << /\\ ";
					if (ycurve == 0) { outfile << "DEF-T" << curvetype << "-"; }
					else { outfile  << "#" << ycurve+1 << "-T" << curvetype << "-"; }
					if (curveapply == 0)
						{
						outfile << "ALL";
						}
					else	{
						if (curveapply < 10)
							{
							outfile << "00" << curveapply;
							}
						if (curveapply >= 10 && curveapply < 100)
							{
							outfile << "0" << curveapply;
							}
						if (curveapply == 100)
							{
							outfile << curveapply;
							}
						}
					outfile << "-";
					if (curveendval < 10)
						{
						outfile << "00" << curveendval << "%  ";
						}
					if (curveendval >= 10 && curveendval < 100)
						{
						outfile << "0" << curveendval << "%  ";
						}
					if (curveendval == 100)
						{
						outfile << curveendval << "%  ";
						}
					}
				}
			}

		cout << "Done.\n\n";
		}

	cout << "Scorefile creation complete!\n";
	return 0;
	}

/*------------------------------------ END OF CALCULATING FUNCTION ----------------------------------*/






/*---------------------------------------- heart of it all! -----------------------------------------*/

int main()
{


	int sendlimit, counter, counter2;
	char test, makesure;
	boolean loop, subloop, boollines, boolunits, boolelements, boolcurve, boolnoofl, boolaccent, booldur, promptcontinue, boolseed;
 	long seedloop, seed, length; 	
	float multiplier;
	string txtinfo, txterror;
	int locnlines, locnunits;
	int total_elem;



//	extern float *ptr_total_dur, *ptr_total_rep, *ptr_tempo_elem;
//	extern int *ptrnlines;
//	extern int *ptrnunits;
//	extern int *ptrnelem;
//	extern int *ptraccent;
//	extern string version;
//	extern boolean array_initialized, boolreinit;	
	


	loop = true;
	boollines = false;
        boolunits = false;
	boolelements = false;
	boolcurve = false;
	boolnoofl = false;
	boolaccent = false;
	booldur = false;
	boolseed = false;
	locnlines = 0;
	locnunits = 0;
	seed = 0;
	counter = 0;
	counter2 = 0;
	total_elem = 0;
	total_dur = 0;
	total_rep = 0;
	tempo_elem = 0;
	promptcontinue = false;



	system("clear"); //CLEAR THE SCREEN
	
	cout << "Welcome to the Stochastic Phrase Structure Generator Version " << version << "!\n\n"
		 << "Copyright Ivica Ico Bukvic 2001 using GNU GPL license v3 or newer\nhttp://ico.bukvic.net <ico@bukvic.net>\n\n"
	     << "For those seeking to learn from the source please note that SPiDSiG is an embarrassingly badly hacked typo-ridden and merrily segfaultin' Linux shell program for generating stochastic structures from conventional scores. For those embarking on the dubious journey of studying SPiDSiG's source code will find plenty of examples of how *not* to code. If you have any appreciation for your free time, my best advice is don't bother.\n"
		 << endl
		 << endl;





	while ( loop )
	{


	      cout << "Please choose from the following options:\n"
	      	   << endl;
	      	   	   
	      cout << "   [H] for HELP\n";

	      if (!boollines)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

	      cout << "[L] for declaration of number of LINE(S)\n";

	      if ( boollines )
		{

	      if (!boolunits)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}


	        cout << "[U] for number of UNITS within each of lines\n";
		}

	      if ( boolunits )
		{


	      if (!boolelements)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

                cout << "[E] for number of ELEMENTS within each unit\n";
		}

              if ( boolelements )
              	{

	      if (!booldur)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

              	cout << "[D] for DURATION and REPETITION options\n";
              	}
              	
              if ( booldur )
              	{

	      if (!boolcurve)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}
         	
                cout << "[V] for declaration of CURVES\n";
		}
		
	      if ( boolelements )
		{

	      if (!boolaccent)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

                cout << "[A] for levels of ACCENTUATION\n";
		}
	      
	      if ( booldur )
		{

	      if (!boolnoofl)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

              cout << "[N] for NUMBER OF LINES TO BE HEARD curve declaration\n";
              	}

	      if (!boolseed)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}			
              cout << "[S] for definition of RANDOM SEED\n";

	      cout << "   [O] for definition of the OUTPUT type\n";
	      cout << endl;
	      
	      if (array_initialized)
		{

	      if (boolreinit)
			{
			cout << " * ";
			}
	      else 	{
			cout << "   ";
			}

		cout << "[R] for REINITIALIZATION of the array\n";
		}
	      if ( boolcurve )
		{
		cout << "   [P] for the REVIEW of the curves\n";
		}
	      if ( boolelements && boolunits && boollines && boolcurve && boolnoofl && boolaccent && booldur && boolseed && !boolreinit )
	      	{
         	cout << " * [C] for CALCULATION of the structure\n";
         	}

       	      cout << endl;
              cout << "   [X] to EXIT the program\n";
	      cout << endl;

	      cout << ">";

	cin >> test;



	if ( test == 'h' || test == 'H' )
		{
		help();
		test = '0';
		}
	
	
	if ( test == 'l' || test == 'L' )
		{
		system("clear"); //CLEAR THE SCREEN
		if ( boollines )
			{
			cout << "If you alter the number of lines now, you might lose some of your data! Continue? (Y/N) ";
			makesure = '0';
			cin >> makesure;
		    }
		if ( boollines && makesure == 'y' || boollines && makesure == 'Y' || !boollines )
		    	{
		    	txtinfo = "Enter a number of lines (i.e. parts) in your score (must be between 1 and 100): ";
		    	txterror = "Oops! Are you sure you want that as your value? Please limit your choice to numbers between 1 and 100 and try again.\n";
		    	sendlimit = 100;
		    	*ptrnlines = linesunits(txtinfo, txterror, sendlimit);
	//			cin >> test;
	//			nlines = atoi(test);
		        boollines = true;
		        //cout << nlines;   //DEBUG
			if (makesure == 'y' || makesure == 'Y') { boolreinit = true; }
			}
		else
			{
			cout << "Your current value of " << nlines << " remains unchanged.\n";
			promptcontinue = true;
			}
		test = '0';	
		}
		
	
	
	if ( test == 'x' || test == 'X' )
		{
		system("clear"); //CLEAR THE SCREEN
		cout << "Are you sure you want to quit? (Y/N) ";
		makesure = '0';
		cin >> makesure;
			if ( makesure == 'y' || makesure == 'Y' )
				{
				loop = false;
				return 0;
				}
			else {makesure = '0';}
		test = '0';
		}
	

	if ( test == 'u' && boollines || test == 'U' &&boollines )
		{
		system("clear"); //CLEAR THE SCREEN
		if ( boolunits )
			{
			cout << "If you alter the number of units now, you might lose some of your data! Continue? (Y/N) ";
			makesure = '0';
			cin >> makesure;
		    }
		if ( boolunits && makesure == 'y' || boolunits && makesure == 'Y' || !boolunits )
		    	{
		    	txtinfo = "Enter a number of units (i.e. measures) in your score: ";
		    	txterror = "Oops! Are you sure you want that as your value? Please limit your choice to numbers between 1 and 5000 and try again.\n";
		    	sendlimit = 5000;
		    	*ptrnunits = linesunits(txtinfo, txterror, sendlimit);
		        boolunits = true;
			if (makesure == 'y' || makesure == 'Y') { boolreinit = true; }
		        //cout << nunits;   //DEBUG
			}
		else
			{
			cout << "Your current value of " << nunits << " remains unchanged.\n";
			promptcontinue = true;
			}
		test = '0';	
		}
		
		
	if ( test == 'e' && boolunits || test == 'E' && boolunits)
		{
		promptcontinue = true;
		system("clear"); //CLEAR THE SCREEN
		if ( boolelements == true )
			{
			makesure = '0';
			cout << "If you alter the number of elements now, you might lose some of your data! Do you wish to reenter data or just edit portion of the data? ([R]eenter/[E]dit/[P]rint current layout/[C]ancel) ";
			cin >> makesure;
		    }
		if ( boolelements && makesure == 'r' || boolelements && makesure == 'R' || !boolelements )
		    		{
				nelements();
				boolelements = true;
				if (makesure == 'r' || makesure == 'R') { boolreinit = true; }
				//cout << *ptrtemparray << endl; //DEBUG
				}
		else if ( boolelements && makesure == 'e' || boolelements && makesure == 'E' )
				{
				editarray(3);
				boolreinit = true;
				}
		else if ( boolelements && makesure == 'p' || boolelements && makesure == 'P' )
				{
				locnlines = *ptrnlines;
				locnunits = *ptrnunits;
				cout << "Current layout of the NUMBER OF ELEMENTS MATRIX:\n";
				for (counter = 0; counter < locnlines; counter++)
					{
					for (counter2 = 0; counter2 < locnunits; counter2++)
						{
						cout << retrieve(3, counter2, counter);
						if (counter2 < *ptrnunits-1) { cout << "-";}
						//cout << *(ptrtemparray+((counter)*locnlines)+counter2) << " "; //OBSOLETE
						//cout << counter2 << " => debugging..." << locnlines << " " << locnunits;       //DEBUG
						}
					cout << endl;	
					}
				cout << endl;
				}				
			else	{
				cout << "Your current array of elements remains unchanged.\n";
				}
		test = '0';	
		}
		
		
		
		
		
		
		

		
	if ( test == 's' || test == 'S' )
		{
		system("clear"); //CLEAR THE SCREEN
		if ( seed > 0 )
			{
			makesure = '0';
			cout << "Current values are: " << seed << " for seed, and " << multiplier << " for multiplier. Change them? (Y/N) ";
			cin >> makesure;
			}
		if ( !seed || makesure == 'y' || makesure == 'Y' )
			{
			seed = getseed();
			multiplier = getmultiplier();
			cout << endl;
			cout << "Entered values are: " << seed << " for seed, and " << multiplier << " for multiplier.\n";
			boolseed = true;
			}
		cout << "Would you like to test current settings? (Y/N) ";
		makesure = '0';
		cin >> makesure;
		if ( makesure == 'y' || makesure =='Y' )
			{
			testrandom(seed, multiplier, 10);
			promptcontinue = true;
			}
		test = '0';
		}



	if ( test == 'd' && boolelements || test == 'D' && boolelements)
		{
		system("clear"); //CLEAR THE SCREEN
		if (booldur)
			{
			makesure = '0';
			cout << "By changing your settings now, some of your data may be lost! Continue? (Y/N) ";
			cin >> makesure;
			}
		if ( makesure == 'y' || makesure == 'Y' || !booldur )
			{
			if (booldur)
				{
				cout << "Wiping out old array data...";
				boolcurve = false;
				boolnoofl = false;
				wipeoutarray();
				}
			promptcontinue = true;
			durrep();
			if (*ptr_total_dur != 0 && *ptr_total_rep != 0 && *ptr_tempo_elem != 0)
				{
				booldur = true;
				}
			else if (*ptr_total_dur == 0 || *ptr_total_rep == 0 || *ptr_tempo_elem == 0)
				{
				booldur = false;
				boolreinit = true;
				}
			}
		test = '0';
		}

	if ( test == 'a' && boolelements || test == 'A' && boolelements)
		{
		system("clear"); //CLEAR THE SCREEN
		if (boolaccent)
			{
			makesure = '0';
			cout << "Do you wish to edit existing levels of accent or do you wish to enter a new array? ([E]dit/[N]ew/[C]ancel) ";
			cin >> makesure;
			}

		if ( makesure == 'n' || makesure == 'N' || !boolaccent )
			{
			if (makesure == 'n' || makesure == 'N') { boolreinit = true; }
			promptcontinue = true;
			accentinit();
			if (*ptraccent > 0 && booldur)
				{
				boolreinit = true;
				}
			boolaccent = true;
			}
		if ( makesure == 'e' || makesure == 'E')
			{
			editarray(5);
			promptcontinue = true;
			if (makesure == 'e' || makesure == 'E') { boolreinit = true; }
			}
		test = '0';
		}	

	
	if ( test == 'r'  && booldur || test == 'R'  && booldur)
		{
		system("clear"); //CLEAR THE SCREEN
		cout << "Wiping out old array data...";
		wipeoutarray();
		cout <<	"Reinitializing array. Please wait...";	
		initarray();
		cout << "Done.\n";
		promptcontinue = true;
		boolreinit = false;
		test = '0';
		}


	if ( test == 'v' && booldur || test == 'V'  && booldur)
		{
		//uses boolcurve
		if (boolcurve)
			{
			makesure = '0';
			cout << "You have already initialized this option. Do you wish to [R]eenter curves, [E]dit curves, or [C]ancel operation? ";
			cin >> makesure;
			}
		if (makesure == 'r' || makesure == 'R' || !boolcurve)
			{
			system("clear"); //CLEAR THE SCREEN
			if (boolcurve)
				{
				cout << "Wiping out old curve array data...";
				wipeoutcurve();
				}
			if (retrieve(4,0,0) != 0)
				{
				curvesedit();
				promptcontinue = true;
				}
			else	{
				ncurves = 0;
				curvesinput();
				boolcurve = true;
				promptcontinue = true;
				}
			}
		if (makesure == 'e' || makesure == 'E')
			{
			curvesedit();
			promptcontinue = true;
			}
		test = '0';
		}


	if ( test == 'o' || test == 'O'  && booldur)
		{
		outputfile();
		promptcontinue = true;
		test = '0';
		}


	if ( test == 'p' && boolcurve || test == 'P'  && boolcurve)
		{
		system("clear"); //CLEAR THE SCREEN
		reviewcurves();
		promptcontinue = true;
		test = '0';
		}

	if ( test == 'n' || test == 'N'  && booldur)
		{
		if (boolnoofl)
			{
			system("clear"); //CLEAR THE SCREEN
			cout << "You have already initialized this option. Do you wish to [R]eenter ranges, [E]dit ranges, [P]rint the current layout, or [C]ancel operation? ";
			makesure = '0';
			cin >> makesure;
			}
		if (makesure == 'r' || makesure == 'R' || !boolnoofl)
			{
			hearlines();
			promptcontinue = true;
			boolnoofl = true;
			}
		if (makesure == 'e' || makesure == 'E')
			{
			edithearline();
			promptcontinue = true;
			}
		if (makesure == 'p' || makesure == 'P')
			{
			cout << endl;
			showcurrenthearline();
			promptcontinue = true;
			}
		test = '0';
		}



	if ( test == 'c' && boolelements && boolunits && boollines && boolcurve && boolnoofl && boolaccent && booldur && boolseed && !boolreinit || test == 'C' &&  boolelements && boolunits && boollines && boolcurve && boolnoofl && boolaccent && booldur && boolseed && !boolreinit )
	//everything must be initialized before user can use this option
		{
		calculate();
		promptcontinue = true;
		}

	if (promptcontinue)
		{
		test = '0';
		cout << "Press [C] to continue...";
		cin >> test;
		promptcontinue = false;
		}



	system("clear"); //CLEAR THE SCREEN

	test = '0';     //NECCESSARY?
				


	//cout << nlines << " " << nunits << " " << test << " " << boollines << endl; 		//DEBUG
	}

	cout << "End of main!\n";               //DEBUG
}


